#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>
#include <stdio.h>
#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>
#include <gst/gst.h>
#include <dirent.h>
#include <libnotify/notify.h>
#include "config.h"

#define IcePlayer_PLAYING 1
#define IcePlayer_PAUSED 2
#define IcePlayer_STOP 3

#define IcePlayer_Normal 0
#define IcePlayer_radom 1
#define IcePlayer_one 2

#define gvoid void

GtkWidget *IcePlayer,*vbox_main,*fixed,*eventbox_main,*image_main,*eventbox_min,*image_min,*eventbox_close,*image_close,*eventbox_play,*image_play,*eventbox_prev,*image_prev,*eventbox_stop,*image_stop,*eventbox_next,*image_next,*hscale_jindu,*hscale_yinliang,*label_info,*label_info2,*label_info3,*hbox_list,*image_list_left,*scrolledwindow,*treeview,*image_list_right,*fixed_list,*eventbox_list_down,*image_list_down,*eventbox_tools_add,*image_tools_add,*eventbox_tools_dele,*image_tools_dele,*eventbox_tools_list,*image_tools_list,*eventbox_tools_mode,*image_tools_mode,*eventbox_left_top,*eventbox_right_down,*eventbox_left_down;
GtkTreeSelection *selection;
GMainLoop *loop;
GstElement *pipeline, *vol;
GtkTreePath *play_path;
gdouble volume =1.0;
gint height2;
gchar uri[1200]={0},name[1200]={0},play_name[1200]={0}, list_file_path[1200],tmp_file_path[1200],config_file_path[1200];
gint play_type=0,list_number=0,play_state = IcePlayer_STOP;
gboolean drag_lock = FALSE,show_iceplayer=FALSE,focus = TRUE;

gvoid About() {
    drag_lock=TRUE;
    GtkWidget *about_dialog;
    const gchar *authors[] = {"slax.jiacheng from Canton Guangdong China  (jasy.ice@163.com)", NULL };
    gchar *translators = "translator-credits";
    about_dialog = gtk_about_dialog_new ();
    gtk_container_set_border_width (GTK_CONTAINER (about_dialog), 5);
    gtk_window_set_destroy_with_parent (GTK_WINDOW (about_dialog), TRUE);
    gtk_about_dialog_set_version (GTK_ABOUT_DIALOG (about_dialog), "3.00");
    gtk_about_dialog_set_name (GTK_ABOUT_DIALOG (about_dialog), "IcePlayer");
    gtk_about_dialog_set_comments (GTK_ABOUT_DIALOG (about_dialog),"My music player.if you has any question,please e-mail to me , i will try my best to help you ! ");
    gtk_about_dialog_set_website (GTK_ABOUT_DIALOG (about_dialog), "jasy.ice.blog.163.com");
    gtk_about_dialog_set_website_label (GTK_ABOUT_DIALOG (about_dialog), "My Blog: jasy.ice.blog.163.com");
    gtk_about_dialog_set_authors (GTK_ABOUT_DIALOG (about_dialog), authors);
    gtk_about_dialog_set_translator_credits (GTK_ABOUT_DIALOG (about_dialog), translators);
    GdkPixbuf *IcePlayer_icon_pixbuf=gdk_pixbuf_new_from_inline  (-1,pix_iceplayer,TRUE,NULL);
    gtk_window_set_icon(GTK_WINDOW(about_dialog),(GdkPixbuf *)IcePlayer_icon_pixbuf);

    gtk_window_set_keep_above     (GTK_WINDOW (about_dialog),TRUE);
    show_iceplayer=TRUE;
    gtk_dialog_run((GtkDialog *) about_dialog);
    gtk_widget_destroy(about_dialog);
    show_iceplayer=FALSE;
}
gvoid init_list(GtkWidget *list) {
    GtkCellRenderer *renderer;
    GtkListStore *store;
    renderer = gtk_cell_renderer_text_new();
    gtk_tree_view_insert_column_with_attributes(GTK_TREE_VIEW(treeview), 0, " ", renderer, "text", 0, NULL);
    gtk_tree_view_insert_column_with_attributes(GTK_TREE_VIEW(treeview), 0, " ", renderer, "text", 1, NULL);
    store = gtk_list_store_new(2, G_TYPE_STRING, G_TYPE_STRING);
    gtk_tree_view_set_model(GTK_TREE_VIEW(list),GTK_TREE_MODEL(store));
    g_object_unref(store);
}
gvoid add_to_list(GtkWidget *list,gchar string[1200],gint add_type) {
    GtkListStore *store;
    GtkTreeIter iter;
    store = GTK_LIST_STORE(gtk_tree_view_get_model(GTK_TREE_VIEW(list)));
    if (add_type == 0) { /*后面*/
        gtk_list_store_append(store, &iter);
    }
    if (add_type == 1) { /*前面*/
        gtk_list_store_prepend(store, &iter);
    }
    if (add_type == 2) { /*正在播放的后面*/
        GtkTreeIter iter_select;
        GtkTreeModel *model_select;
        GList *list_select = gtk_tree_selection_get_selected_rows(GTK_TREE_SELECTION(gtk_tree_view_get_selection(GTK_TREE_VIEW(list))),&model_select);
        if (list_select) { /*如果播放列表并无选择就插入到前面*/
            gtk_tree_model_get_iter(model_select, &iter_select, (GtkTreePath *) list_select->data);
            gtk_list_store_insert_after(store, &iter,&iter_select);
        } else {
            gtk_list_store_prepend(store, &iter);
        }
    }
    if (strcmp(string,play_name)==0) {
        gtk_list_store_set(store, &iter,0,string,1,"♥", -1);
    }

    else {
        gtk_list_store_set(store, &iter,0,string,1,"   ", -1);
    }
}
gboolean get_list_number(GtkTreeModel *model,GtkTreePath *path,GtkTreeIter *iter,gpointer user_data) {
    list_number++;
    return FALSE;
}
gvoid set_volume(gdouble volume2) {
    if (pipeline) {
        if (volume2>1.0) volume2=1.0;
        if (volume2<0) volume2=0;
        vol=gst_bin_get_by_name(GST_BIN(pipeline), "volume");
        if (vol==NULL) return;
        g_object_set(vol, "volume",volume2, NULL);
        volume=volume2;
    }
}
gboolean on_treeview_selection_changed (GtkTreeSelection *selection,gpointer user_data) {
    gchar filename[1200];
    GtkTreeIter iter;
    GtkTreeModel *model;
    gchar *value;
    GList *list = gtk_tree_selection_get_selected_rows(GTK_TREE_SELECTION(selection),&model);
    if (list != NULL) {
        if (gtk_tree_model_get_iter(model, &iter, (GtkTreePath *) list->data)) {
            gtk_tree_model_get(model, &iter, 0, &value, -1);
            FILE *filelst = fopen(list_file_path,"a+");
            while (fgets(filename,1200,filelst) !=NULL) {
                filename[strlen(filename)-1] = '\0';
                if (strcmp(filename,value) ==0) {
                    strcpy(name,filename);
                    if (fgets(filename,1200,filelst));
                    filename[strlen(filename)-1] = '\0';
                    strcpy(uri,filename);
                }
            }
            fclose(filelst);
            g_free(value);
        }
    }
    return FALSE;
}
gboolean bus_call(GstBus *bus, GstMessage *msg, gpointer user_data) {
    gvoid play_uri() ;
    switch (GST_MESSAGE_TYPE(msg)) {
    case GST_MESSAGE_ERROR:
    case GST_MESSAGE_EOS: {
        if (play_type==0) {
            list_number=0;
            GtkTreeModel *model = gtk_tree_view_get_model(GTK_TREE_VIEW(treeview));
            gtk_tree_model_foreach(model, (GtkTreeModelForeachFunc)get_list_number,NULL);
            gtk_tree_path_next(play_path);
            gtk_tree_view_set_cursor((GtkTreeView *) treeview,play_path, gtk_tree_view_get_column((GtkTreeView *) treeview,0), FALSE);
            gchar *b=gtk_tree_path_to_string(play_path);
            gint a= atoi(b);
            if (a>=list_number) {
                if (pipeline) gst_element_set_state(pipeline, GST_STATE_NULL);
                play_state = IcePlayer_STOP;
                gtk_range_set_value((GtkRange *) hscale_jindu, 0);
                gtk_label_set_text(GTK_LABEL(label_info3),"00.00:00-00.00:00");
                gtk_label_set_text(GTK_LABEL(label_info2),"状态：停止                                                                                                                    ");
                gtk_label_set_text(GTK_LABEL(label_info),"IcePlayer 听你想听                                                                                                               ");
                gtk_container_remove(GTK_CONTAINER(eventbox_play),image_play);
                image_play=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_play,TRUE,NULL));
                gtk_widget_show(image_play);
                gtk_container_add(GTK_CONTAINER(eventbox_play),image_play);
            } else {
                play_state = IcePlayer_PLAYING;
                if (pipeline) gst_element_set_state(pipeline, GST_STATE_NULL);
                play_uri();
            }
        }
        if (play_type==1) {
            list_number=0;
            gchar b[4];
            srand((unsigned)time(NULL)+1);
            GtkTreeModel *model = gtk_tree_view_get_model(GTK_TREE_VIEW(treeview));
            gtk_tree_model_foreach(model, (GtkTreeModelForeachFunc)get_list_number,NULL);
            list_number=rand()%list_number;
            sprintf(b,"%d",list_number);
            GtkTreePath *path = gtk_tree_path_new_from_string(b);
            gtk_tree_view_set_cursor((GtkTreeView *) treeview,path, gtk_tree_view_get_column((GtkTreeView *) treeview,0), FALSE);
            on_treeview_selection_changed ((GtkTreeSelection *)gtk_tree_view_get_selection(GTK_TREE_VIEW(treeview)),NULL);
            play_path = path;
            if (pipeline) gst_element_set_state(pipeline, GST_STATE_NULL);
            play_state = IcePlayer_PLAYING;
            play_uri();
        }
        if (play_type==2) {
            gtk_tree_view_set_cursor((GtkTreeView *) treeview,play_path, gtk_tree_view_get_column((GtkTreeView *) treeview,0), FALSE);
            if (pipeline) gst_element_set_state(pipeline, GST_STATE_NULL);
            play_state = IcePlayer_PLAYING;
            play_uri();
        }
    }
    save_config();
    break;
    default:
        if (volume > 1) volume=1;
        set_volume(volume);
        break;
    }
    return 1;
}
gboolean clear_colum_one(GtkTreeModel *model,GtkTreePath *path,GtkTreeIter *iter,gpointer user_data) {
    gchar *value;
    gtk_tree_model_get(model, iter, 0, &value,-1);
    gtk_tree_model_get_iter(model, iter, path);
    gtk_list_store_set((GtkListStore *)model, iter,0,value,1,"   ", -1);
    return FALSE;
}
gvoid play_uri() {
    if (loop) g_main_loop_quit(loop);
    if (pipeline) gst_element_set_state(GST_ELEMENT(pipeline), GST_STATE_NULL);
    gchar * markup;
    markup = g_markup_printf_escaped("%s                                                                                                                          . ",name);
    gtk_label_set_markup(GTK_LABEL(label_info),markup);
    gtk_label_set_text(GTK_LABEL(label_info2),"状态：播放                                                                                                                    ");
    if (system("pkill notify-osd"));
    notify_init("IcePlayer");
    NotifyNotification *notify = notify_notification_new("播放", name, NULL, NULL);
    notify_notification_show(notify, NULL);
    gtk_container_remove(GTK_CONTAINER(eventbox_play),image_play);
    image_play=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_pause,TRUE,NULL));
    gtk_widget_show(image_play);
    gtk_container_add(GTK_CONTAINER(eventbox_play),image_play);
    play_state = IcePlayer_PLAYING;
    loop = g_main_loop_new(NULL, TRUE);
    pipeline = NULL;
    pipeline = gst_element_factory_make("playbin", "player");
    g_object_set(G_OBJECT(pipeline), "uri",uri, NULL);
    gtk_tree_model_foreach(gtk_tree_view_get_model( (GtkTreeView *)treeview), (GtkTreeModelForeachFunc) clear_colum_one,NULL);
    GtkListStore *store = GTK_LIST_STORE(gtk_tree_view_get_model( (GtkTreeView   *)treeview));
    GtkTreeIter iter;
    gtk_tree_model_get_iter( (GtkTreeModel *)store, &iter, play_path);
    gtk_list_store_set(store, &iter,0,name,1,"♥", -1);
    strcpy(play_name,name);
    save_config();
    gtk_range_set_value((GtkRange *) hscale_jindu, 0);
    GstBus *bus;
    bus = gst_pipeline_get_bus(GST_PIPELINE(pipeline));
    gst_bus_add_watch(bus, bus_call, NULL);
    gst_object_unref(bus);
    if (pipeline) gst_element_set_state(GST_ELEMENT(pipeline), GST_STATE_PLAYING);
    g_main_loop_run(loop);
    if (pipeline) gst_element_set_state(GST_ELEMENT(pipeline), GST_STATE_NULL);
}
gvoid Open_Dialog(GtkMenuItem *item, gpointer user_data) {
    GtkWidget *filechooserdialog;
    GtkWidget *dialog_vbox1;
    GtkWidget *hbox1;
    GtkWidget *radiobutton1;
    GSList *radiobutton1_group = NULL;
    GtkWidget *radiobutton2;
    GtkWidget *radiobutton3;
    GtkWidget *dialog_action_area1;
    GtkWidget *button1;
    GtkWidget *button2;

    const gchar *title = gtk_menu_item_get_label(item);
    if (!strcmp(title,"选择文件")) {
        filechooserdialog = gtk_file_chooser_dialog_new("", NULL,GTK_FILE_CHOOSER_ACTION_OPEN, NULL,NULL);
        g_object_set(filechooserdialog,"select-multiple", TRUE,NULL);
    } else {
        filechooserdialog = gtk_file_chooser_dialog_new("", NULL,GTK_FILE_CHOOSER_ACTION_SELECT_FOLDER, NULL,NULL);
    }
    gtk_container_set_border_width(GTK_CONTAINER(filechooserdialog), 5);
    gtk_window_set_position(GTK_WINDOW(filechooserdialog), GTK_WIN_POS_CENTER);
    gtk_window_set_type_hint(GTK_WINDOW(filechooserdialog), GDK_WINDOW_TYPE_HINT_DIALOG);
    GdkPixbuf *IcePlayer_icon_pixbuf=gdk_pixbuf_new_from_inline  (-1,pix_iceplayer,TRUE,NULL);
    gtk_window_set_icon(GTK_WINDOW(filechooserdialog),(GdkPixbuf *)IcePlayer_icon_pixbuf);
    gtk_window_set_keep_above     (GTK_WINDOW (filechooserdialog),TRUE);

    dialog_vbox1 = GTK_DIALOG(filechooserdialog)->vbox;
    gtk_widget_show(dialog_vbox1);
    hbox1 = gtk_hbox_new(FALSE, 0);
    gtk_widget_show(hbox1);
    gtk_box_pack_start(GTK_BOX(dialog_vbox1), hbox1, FALSE, FALSE, 0);

    radiobutton1 = gtk_radio_button_new_with_mnemonic(NULL, "添加于列表所选之后");
    gtk_widget_show(radiobutton1);
    gtk_box_pack_start(GTK_BOX(hbox1), radiobutton1, FALSE, FALSE, 0);
    gtk_radio_button_set_group(GTK_RADIO_BUTTON(radiobutton1), radiobutton1_group);
    radiobutton1_group = gtk_radio_button_get_group(GTK_RADIO_BUTTON(radiobutton1));

    radiobutton2 = gtk_radio_button_new_with_mnemonic(NULL, "添加于当前列表最前");
    gtk_widget_show(radiobutton2);
    gtk_box_pack_start(GTK_BOX(hbox1), radiobutton2, FALSE, FALSE, 0);
    gtk_radio_button_set_group(GTK_RADIO_BUTTON(radiobutton2), radiobutton1_group);
    radiobutton1_group = gtk_radio_button_get_group(GTK_RADIO_BUTTON(radiobutton2));

    radiobutton3 = gtk_radio_button_new_with_mnemonic(NULL, "添加于当前列表最后");
    gtk_widget_show(radiobutton3);
    gtk_box_pack_start(GTK_BOX(hbox1), radiobutton3, FALSE, FALSE, 0);
    gtk_radio_button_set_group(GTK_RADIO_BUTTON(radiobutton3), radiobutton1_group);

    radiobutton1_group = gtk_radio_button_get_group(GTK_RADIO_BUTTON(radiobutton3));
    dialog_action_area1 = GTK_DIALOG(filechooserdialog)->action_area;
    gtk_widget_show(dialog_action_area1);
    gtk_button_box_set_layout(GTK_BUTTON_BOX(dialog_action_area1), GTK_BUTTONBOX_END);

    button1 = gtk_button_new_from_stock("gtk-cancel");
    gtk_widget_show(button1);
    gtk_dialog_add_action_widget(GTK_DIALOG(filechooserdialog), button1, GTK_RESPONSE_CANCEL);
    GTK_WIDGET_SET_FLAGS(button1, GTK_CAN_DEFAULT);

    button2 = gtk_button_new_from_stock("gtk-open");
    gtk_widget_show(button2);
    gtk_dialog_add_action_widget(GTK_DIALOG(filechooserdialog), button2, GTK_RESPONSE_OK);
    GTK_WIDGET_SET_FLAGS(button2, GTK_CAN_DEFAULT);

    gtk_widget_grab_focus(radiobutton3);
    gtk_widget_grab_default(button2);

    GtkFileFilter* filter = gtk_file_filter_new();
    gtk_file_filter_set_name(filter, "媒体文件");

    gtk_file_filter_add_pattern(filter,"*.[Mm][Pp][3]");
    gtk_file_filter_add_pattern(filter,"*.[Ww][Mm][Aa]");
    gtk_file_filter_add_pattern(filter,"*.[Oo][Gg][Gg]");
    gtk_file_filter_add_pattern(filter,"*.[Ww][Aa][Vv]");
    gtk_file_filter_add_pattern(filter,"*.[Aa][Pp][Ee]");
    gtk_file_filter_add_pattern(filter,"*.[Ff][Ll][Aa][Cc]");
    gtk_file_filter_add_pattern(filter,"*.[AA][Cc][Cc]");
    gtk_file_filter_add_pattern(filter,"*.[Oo][Gg][Vv]");

    gtk_file_filter_add_pattern(filter,"*.[Ww][Mm][Vv]");
    gtk_file_filter_add_pattern(filter,"*.[Dd][Aa][Tt]");
    gtk_file_filter_add_pattern(filter,"*.[Mm][Kk][Vv]");
    gtk_file_filter_add_pattern(filter,"*.[Mm][Pp][Gg]");
    gtk_file_filter_add_pattern(filter,"*.[Mm][Pp][4]");
    gtk_file_filter_add_pattern(filter,"*.[Rr][Mm]");
    gtk_file_filter_add_pattern(filter,"*.[Rr][Mm][Vv][Bb]");
    gtk_file_filter_add_pattern(filter,"*.[Aa][Vv][Ii]");
    gtk_file_filter_add_pattern(filter,"*.[Ff][Ll][Vv]");

    gtk_file_chooser_add_filter(GTK_FILE_CHOOSER(filechooserdialog),filter);

    gtk_toggle_button_set_active((GtkToggleButton *) radiobutton3,TRUE);

    static gchar * path;
    if (path) { /*下次打开对话框时便回到上一文件夹*/
        gint as=0;
        gchar path2[1200];
        strcpy(path2,path);
        as = strlen(path2);
        while (path2[as]!='/') {
            as--;
        }
        path2[as] = '\0';
        gtk_file_chooser_set_current_folder((GtkFileChooser *) filechooserdialog,path2);
    }
    while (1) {
        drag_lock=TRUE;
        show_iceplayer=TRUE;
        gtk_window_set_focus ((GtkWindow *)IcePlayer,button2);
        gint aw = gtk_dialog_run((GtkDialog *) filechooserdialog);
        show_iceplayer=FALSE;
        if (aw==-5) {
            if (!strcmp(title,"选择文件")) {
                path = gtk_file_chooser_get_current_folder((GtkFileChooser *) filechooserdialog);
                GSList *list = gtk_file_chooser_get_filenames((GtkFileChooser *) filechooserdialog);
                while (list != NULL) {
                    strcpy(uri,"file://");
                    strcat(uri,list->data);
                    uri[strlen(uri)] = '\0';
                    gint n,b;
                    b=n=strlen(uri);
                    while (uri[n-1]!='/') {
                        n--;
                    }
                    gint m=0;
                    for (;n!=b;n++) {
                        name[m] = uri[n];
                        m++;
                    }
                    name[m] = '\0';
                    gint number=0;
                    FILE *filelst = fopen(list_file_path,"at+");
                    gchar filename[1200];
                    while (fgets(filename,1200,filelst) !=NULL) {
                        filename[strlen(filename)-1] = '\0';
                        if (strcmp(filename,name) ==0) {
                            number ++;
                        }
                    }
                    fclose(filelst);
                    gint num = 0;
                    while (1) {
                        if (number) {
                            gchar A[100];
                            g_snprintf(A,100,"^(%d)",number++);
                            strcat(name,A);
                        }
                        FILE *filelst = fopen(list_file_path,"at+");
                        while (fgets(filename,1200,filelst) !=NULL) {
                            filename[strlen(filename)-1] = '\0';
                            if (strcmp(filename,name) ==0) {
                                num ++;
                                break;
                            }
                        }
                        fclose(filelst);
                        if (num!=0) {
                            num=0;
                            name[m-4] = '\0';
                        } else
                            break;
                    }
                    FILE *listfile = fopen(list_file_path,"at+");
                    fputs(name,listfile);
                    fputc('\n',listfile);
                    fputs(uri,listfile);
                    fputc('\n',listfile);
                    fclose(listfile);
                    gint add_type = 0;
                    if (gtk_toggle_button_get_active((GtkToggleButton *) radiobutton1))
                        add_type = 2;
                    if (gtk_toggle_button_get_active((GtkToggleButton *) radiobutton2))
                        add_type = 1;
                    if (gtk_toggle_button_get_active((GtkToggleButton *) radiobutton3))
                        add_type = 0;
                    add_to_list(treeview,name,add_type);
                    list = list->next;
                }
                gtk_widget_destroy(filechooserdialog);
                break;
            } else {
                path = gtk_file_chooser_get_current_folder((GtkFileChooser *) filechooserdialog);
                DIR * dir;
                struct dirent * ptr;
                dir=opendir(path);
                ptr=readdir(dir);
                while (ptr !=NULL) {
                    if ( strstr(ptr->d_name,".MP3")||strstr(ptr->d_name,".WMA")||strstr(ptr->d_name,".OGG")||strstr(ptr->d_name,".WAV")||strstr(ptr->d_name,".APE")||strstr(ptr->d_name,".FLAC")||strstr(ptr->d_name,".ACC")||strstr(ptr->d_name,".OGV")||strstr(ptr->d_name,".WMV")||strstr(ptr->d_name,".DAT")||strstr(ptr->d_name,".MKV")||strstr(ptr->d_name,".MPG")||strstr(ptr->d_name,".MP4")||strstr(ptr->d_name,".RM")||strstr(ptr->d_name,".RMVB")||strstr(ptr->d_name,".AVI")||strstr(ptr->d_name,".FLV")||strstr(ptr->d_name,".mp3")||strstr(ptr->d_name,".wma")||strstr(ptr->d_name,".ogg")||strstr(ptr->d_name,".wav")||strstr(ptr->d_name,".ape")||strstr(ptr->d_name,".flac")||strstr(ptr->d_name,".acc")||strstr(ptr->d_name,".ogv")||strstr(ptr->d_name,".wmv")||strstr(ptr->d_name,".dat")||strstr(ptr->d_name,".mkv")||strstr(ptr->d_name,".mpg")||strstr(ptr->d_name,".mp4")||strstr(ptr->d_name,".rm")||strstr(ptr->d_name,".rmvb")||strstr(ptr->d_name,".avi")||strstr(ptr->d_name,".flv")) {
                        gchar path3[1200];
                        strcpy(path3,path);
                        strcat(path3,"/");
                        strcat(path3,ptr->d_name);
                        if (!opendir(path3)) {
                            strcpy(uri,"file://");
                            strcat(uri,path);
                            strcat(uri,"/");
                            strcat(uri,ptr->d_name);
                            uri[strlen(uri)] = '\0';
                            gint n,b;
                            b=n=strlen(uri);
                            while (uri[n-1]!='/') {
                                n--;
                            }
                            gint m=0;
                            for (;n!=b;n++) {
                                name[m] = uri[n];
                                m++;
                            }
                            name[m] = '\0';
                            gint number=0;
                            FILE *filelst = fopen(list_file_path,"at+");
                            gchar filename[1200];
                            while (fgets(filename,1200,filelst) !=NULL) {
                                filename[strlen(filename)-1] = '\0';
                                if (strcmp(filename,name) ==0) {
                                    number ++;
                                }
                            }
                            fclose(filelst);
                            gint num = 0;
                            while (1) {
                                if (number) {
                                    gchar A[100];
                                    g_snprintf(A,100,"^(%d)",number++);
                                    strcat(name,A);
                                }
                                FILE *filelst = fopen(list_file_path,"at+");
                                while (fgets(filename,1200,filelst) !=NULL) {
                                    filename[strlen(filename)-1] = '\0';
                                    if (strcmp(filename,name) ==0) {
                                        num ++;
                                        break;
                                    }
                                }
                                fclose(filelst);
                                if (num!=0) {
                                    num=0;
                                    name[m-4] = '\0';
                                } else
                                    break;
                            }
                            FILE *listfile = fopen(list_file_path,"at+");
                            fputs(name,listfile);
                            fputc('\n',listfile);
                            fputs(uri,listfile);
                            fputc('\n',listfile);
                            fclose(listfile);
                            gint add_type = 0;
                            if (gtk_toggle_button_get_active((GtkToggleButton *) radiobutton1))
                                add_type = 2;
                            if (gtk_toggle_button_get_active((GtkToggleButton *) radiobutton2))
                                add_type = 1;
                            if (gtk_toggle_button_get_active((GtkToggleButton *) radiobutton3))
                                add_type = 0;
                            add_to_list(treeview,name,add_type);
                        }
                    }
                    ptr=readdir(dir);
                }
                closedir(dir);
                gtk_widget_destroy(filechooserdialog);
                break;
            }
        } else {
            gtk_widget_destroy(filechooserdialog);
            break;
        }
    }
}
gvoid Play_Type(GtkMenuItem *item, gpointer user_data) {
    const gchar *title = gtk_menu_item_get_label(item);
    if (!strcmp(title,"顺序播放")) {
        play_type = IcePlayer_Normal;
    }
    if (!strcmp(title,"随机播放")) {
        play_type = IcePlayer_radom;
    }
    if (!strcmp(title,"单曲循环")) {
        play_type = IcePlayer_one;
    }
}
gboolean update_time() {
    if (pipeline&&(play_state!=IcePlayer_STOP)) {
        GstFormat fmt = GST_FORMAT_TIME;
        gint64 pos;
        gint64 length;
        gst_element_query_position(pipeline, &fmt, &pos);
        gst_element_query_duration(pipeline, &fmt, &length);
        if (length>0) {
            gchar A[60];
            gchar B[25];
            if (pos<=length) {
                gtk_range_set_value((GtkRange *) hscale_jindu, ((((gdouble) pos) / ((gdouble) length)) *100.0));
                gtk_range_set_range((GtkRange *) hscale_jindu, 0.0, (length/1000000000));
                gtk_range_set_value((GtkRange *) hscale_jindu, (pos/1000000000));
            }
            g_snprintf(A,24,"%02u.%02u:%02u%d",GST_TIME_ARGS(pos));
            g_snprintf(B,24,"%02u.%02u:%02u%d",GST_TIME_ARGS(length));
            A[8] = 0;
            B[8] = 0;
            strcat(A,"-");
            strcat(A,B);
            //if (strlen(A)==17) {
                gtk_label_set_text(GTK_LABEL(label_info3),A);
            //}
        }
    } else {
        gtk_label_set_text(GTK_LABEL(label_info3),"00.00:00-00.00:00");
        gtk_range_set_value((GtkRange *) hscale_jindu, 0);
    }
    gint width,height;
    gint x,y;
    gint sx,sy;
    gtk_window_get_size ( (GtkWindow *)IcePlayer,&width,&height);
    if (width!=300||height<=170) {
        if (height!=3) {
            gtk_window_unfullscreen((GtkWindow *)IcePlayer) ;
            gtk_window_unmaximize ((GtkWindow *)IcePlayer);
            gtk_window_get_size ( (GtkWindow *)IcePlayer,&width,&height);
            if (width!=300||height<=170)gtk_window_resize((GtkWindow *)IcePlayer,300,height2);
            return TRUE;

        }
    } else {
        if (height>170)height2 = height;
    }
    gtk_window_get_position( (GtkWindow *)IcePlayer,&x,&y);
    gdk_window_get_pointer( NULL,&sx,&sy,NULL);

    if (focus||((!show_iceplayer)&&(y<=5&&sy<=13&&sx>x-20&&sx<x+width+20))) {
        if (!drag_lock) {
            if (height2>170)gtk_window_resize((GtkWindow *)IcePlayer,300,height2);
            gtk_window_set_keep_above     (GTK_WINDOW (IcePlayer),TRUE);
        }
        return TRUE;
    }
    if ((!focus&&y<=5&&((sx<x-20||sx>=x+width+20)||(sy>=height2+20)))||((!show_iceplayer)&&y<=5&&((sx<x-20||sx>=x+width+20)||(sy>=height2+20)))) {
        if (!drag_lock) {
            if (height!=3)height2 = height;
            gtk_window_resize((GtkWindow *)IcePlayer,300,3);
            gtk_window_set_keep_above     (GTK_WINDOW (IcePlayer),TRUE);
        } else {
            if (height2>170) gtk_window_resize((GtkWindow *)IcePlayer,300,height2);
            gtk_window_set_keep_above     (GTK_WINDOW (IcePlayer),TRUE);
        }
        return TRUE;
    }
    if (y>5)gtk_window_set_keep_above     (GTK_WINDOW (IcePlayer),FALSE);
    if (y>5) if (height!=3)height2 = height;
    return TRUE;
}
gvoid hide  () {
    gtk_window_iconify (GTK_WINDOW(IcePlayer) );
}
gvoid view  () {
    gint x,y;
    if (!gtk_window_is_active((GtkWindow           *)IcePlayer)) {
        gtk_window_deiconify (GTK_WINDOW(IcePlayer) );
    }
    show_iceplayer = TRUE;
    if (height2>=3)gtk_window_resize((GtkWindow *)IcePlayer,300,height2);
    gtk_window_get_position( (GtkWindow *)IcePlayer,&x,&y);
    gtk_widget_hide(IcePlayer);
    gtk_widget_show(IcePlayer);
    gtk_window_move( (GtkWindow *)IcePlayer,x,y);
}
gvoid play  () {
    if (play_state==IcePlayer_STOP)uri[0]=0;
    selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(treeview));
    on_treeview_selection_changed(selection,NULL);
    if (uri[0] == 0) {
        gtk_tree_view_set_cursor((GtkTreeView *) treeview,gtk_tree_path_new_first(),gtk_tree_view_get_column((GtkTreeView *) treeview,0),FALSE);
        GtkTreeModel *model;
        GList *list = gtk_tree_selection_get_selected_rows(gtk_tree_view_get_selection(GTK_TREE_VIEW(treeview)),&model);
        if (list) play_path = (GtkTreePath *) list->data;
    }
    GtkTreeModel *model;
    GList *list = gtk_tree_selection_get_selected_rows(gtk_tree_view_get_selection(GTK_TREE_VIEW(treeview)),&model);
    if (list) {
        switch (play_state) {
        case IcePlayer_PLAYING:
            if (pipeline) {
                if (pipeline) gst_element_set_state(pipeline, GST_STATE_PAUSED);
                gtk_label_set_text(GTK_LABEL(label_info2),"状态：暂停                                                                                                                    ");
                play_state = IcePlayer_PAUSED;
                g_object_set(vol, "volume",0.0, NULL);
                gtk_container_remove(GTK_CONTAINER(eventbox_play),image_play);
                image_play=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_pause,TRUE,NULL));
                gtk_widget_show(image_play);
                gtk_container_add(GTK_CONTAINER(eventbox_play),image_play);
            }
            break;
        case IcePlayer_PAUSED:
            if (pipeline) {
                if (pipeline) gst_element_set_state(pipeline, GST_STATE_PLAYING);
                gtk_label_set_text(GTK_LABEL(label_info2),"状态：播放                                                                                                                    ");
                play_state = IcePlayer_PLAYING;
                g_object_set(vol, "volume",volume, NULL);
                gtk_container_remove(GTK_CONTAINER(eventbox_play),image_play);
                image_play=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_play,TRUE,NULL));
                gtk_widget_show(image_play);
                gtk_container_add(GTK_CONTAINER(eventbox_play),image_play);
            }
            break;
        case IcePlayer_STOP:
            play_path = (GtkTreePath *) list->data;
            if (uri[0]) play_uri();
            gtk_container_remove(GTK_CONTAINER(eventbox_play),image_play);
            image_play=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_pause,TRUE,NULL));
            gtk_widget_show(image_play);
            gtk_container_add(GTK_CONTAINER(eventbox_play),image_play);
            break;
        }
    } else {
        switch (play_state) {
        case IcePlayer_PLAYING:
            if (pipeline) {
                if (pipeline) gst_element_set_state(pipeline, GST_STATE_PAUSED);
                gtk_label_set_text(GTK_LABEL(label_info2),"状态：暂停                                                                                                                    ");
                play_state = IcePlayer_PAUSED;
                g_object_set(vol, "volume",0.0, NULL);
                gtk_container_remove(GTK_CONTAINER(eventbox_play),image_play);
                image_play=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_pause,TRUE,NULL));
                gtk_widget_show(image_play);
                gtk_container_add(GTK_CONTAINER(eventbox_play),image_play);
            }
            break;
        case IcePlayer_PAUSED:
            if (pipeline) {
                if (pipeline) gst_element_set_state(pipeline, GST_STATE_PLAYING);
                gtk_label_set_text(GTK_LABEL(label_info2),"状态：播放                                                                                                                    ");
                play_state = IcePlayer_PLAYING;
                g_object_set(vol, "volume",volume, NULL);
                gtk_container_remove(GTK_CONTAINER(eventbox_play),image_play);
                image_play=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_play,TRUE,NULL));
                gtk_widget_show(image_play);
                gtk_container_add(GTK_CONTAINER(eventbox_play),image_play);
            }
            break;
        case IcePlayer_STOP:
            if (uri[0]) {
                play_uri();
                gtk_container_remove(GTK_CONTAINER(eventbox_play),image_play);
                image_play=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_pause,TRUE,NULL));
                gtk_widget_show(image_play);
                gtk_container_add(GTK_CONTAINER(eventbox_play),image_play);
                play_path = (GtkTreePath *) list->data;
            } else {
                GtkWidget * menu = gtk_menu_new();
                GtkWidget *menu_Open_file = gtk_image_menu_item_new_with_mnemonic("选择文件");
                gtk_menu_shell_append(GTK_MENU_SHELL(menu),menu_Open_file);
                GtkWidget *menu_Open_folder = gtk_image_menu_item_new_with_mnemonic("添加文件夹");
                gtk_menu_shell_append(GTK_MENU_SHELL(menu),menu_Open_folder);
                g_signal_connect(menu_Open_file ,"activate",G_CALLBACK(Open_Dialog),NULL);
                g_signal_connect(menu_Open_folder ,"activate",G_CALLBACK(Open_Dialog),NULL);
                gtk_widget_show_all(menu);
                drag_lock=TRUE;
                gtk_menu_popup(GTK_MENU(menu),NULL,NULL,NULL,NULL,3,gtk_get_current_event_time());
                break;
            }
            break;
        }
    }
}
gvoid next  () {
    selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(treeview));
    on_treeview_selection_changed(selection,NULL);
    if (uri[0] == 0) {
        gtk_tree_view_set_cursor((GtkTreeView *) treeview,gtk_tree_path_new_first(),gtk_tree_view_get_column((GtkTreeView *) treeview,0),FALSE);
        GtkTreeModel *model;
        GList *list = gtk_tree_selection_get_selected_rows(gtk_tree_view_get_selection(GTK_TREE_VIEW(treeview)),&model);
        if (list) play_path = (GtkTreePath *) list->data;
        if (play_path) gtk_tree_view_set_cursor((GtkTreeView *) treeview,play_path, gtk_tree_view_get_column((GtkTreeView *) treeview,0), FALSE);
        if (pipeline) gst_element_set_state(pipeline, GST_STATE_NULL);
        if (uri[0]) play_uri();
    } else {
        if (play_type==0) {
            list_number=0;
            GtkTreeModel *model = gtk_tree_view_get_model(GTK_TREE_VIEW(treeview));
            GList *list = gtk_tree_selection_get_selected_rows(gtk_tree_view_get_selection(GTK_TREE_VIEW(treeview)),&model);
            if (list) play_path = (GtkTreePath *) list->data;
            gtk_tree_model_foreach(model, (GtkTreeModelForeachFunc)get_list_number,NULL);
            gtk_tree_path_next(play_path);
            gtk_tree_view_set_cursor((GtkTreeView *) treeview,play_path, gtk_tree_view_get_column((GtkTreeView *) treeview,0), FALSE);
            gchar *b=gtk_tree_path_to_string(play_path);
            gint a= atoi(b);
            if (a>=list_number) {
                if (pipeline) gst_element_set_state(pipeline, GST_STATE_NULL);
                play_state = IcePlayer_STOP;
                gtk_range_set_value((GtkRange *) hscale_jindu, 0);
                gtk_label_set_text(GTK_LABEL(label_info2),"状态：停止                                                                                                                    ");
                gtk_label_set_text(GTK_LABEL(label_info),"IcePlayer 听你想听                                                                                                               ");
                gtk_container_remove(GTK_CONTAINER(eventbox_play),image_play);
                image_play=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_play,TRUE,NULL));
                gtk_widget_show(image_play);
                gtk_container_add(GTK_CONTAINER(eventbox_play),image_play);
            } else {
                play_state = IcePlayer_PLAYING;
                if (pipeline) gst_element_set_state(pipeline, GST_STATE_NULL);
                play_uri();
            }
        }
        if (play_type==1) {
            list_number=0;
            gchar b[4];
            srand((unsigned)time(NULL)+1);
            GtkTreeModel *model = gtk_tree_view_get_model(GTK_TREE_VIEW(treeview));
            gtk_tree_model_foreach(model, (GtkTreeModelForeachFunc)get_list_number,NULL);
            list_number=rand()%list_number;
            sprintf(b,"%d",list_number);
            GtkTreePath *path = gtk_tree_path_new_from_string(b);
            gtk_tree_view_set_cursor((GtkTreeView *) treeview,path, gtk_tree_view_get_column((GtkTreeView *) treeview,0), FALSE);
            on_treeview_selection_changed (gtk_tree_view_get_selection(GTK_TREE_VIEW(treeview)),NULL);
            play_path = path;
            if (pipeline) gst_element_set_state(pipeline, GST_STATE_NULL);
            play_state = IcePlayer_PLAYING;
            play_uri();
        }
        if (play_type==2) {
            gtk_tree_view_set_cursor((GtkTreeView *) treeview,play_path, gtk_tree_view_get_column((GtkTreeView *) treeview,0), FALSE);
            if (pipeline) gst_element_set_state(pipeline, GST_STATE_NULL);
            play_state = IcePlayer_PLAYING;
            play_uri();
        }
    }
}
gvoid prev  () {
    selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(treeview));
    on_treeview_selection_changed(selection,NULL);
    if (uri[0] == 0) {
        gtk_tree_view_set_cursor((GtkTreeView *) treeview,gtk_tree_path_new_first(),gtk_tree_view_get_column((GtkTreeView *) treeview,0),FALSE);
        GtkTreeModel *model;
        GList *list = gtk_tree_selection_get_selected_rows(gtk_tree_view_get_selection(GTK_TREE_VIEW(treeview)),&model);
        if (list) play_path = (GtkTreePath *) list->data;
        if (play_path) gtk_tree_view_set_cursor((GtkTreeView *) treeview,play_path, gtk_tree_view_get_column((GtkTreeView *) treeview,0), FALSE);
        if (pipeline) gst_element_set_state(pipeline, GST_STATE_NULL);
        if (uri[0]) play_uri();
    } else {
        if (play_type==0) {
            list_number=0;
            GtkTreeModel *model = gtk_tree_view_get_model(GTK_TREE_VIEW(treeview));
            GList *list = gtk_tree_selection_get_selected_rows(gtk_tree_view_get_selection(GTK_TREE_VIEW(treeview)),&model);
            if (list) play_path = (GtkTreePath *) list->data;
            gtk_tree_model_foreach(model, (GtkTreeModelForeachFunc)get_list_number,NULL);
            if (play_path) gtk_tree_path_prev(play_path);
            gtk_tree_view_set_cursor((GtkTreeView *) treeview,play_path, gtk_tree_view_get_column((GtkTreeView *) treeview,0), FALSE);
            gchar *b=gtk_tree_path_to_string(play_path);
            gint a= atoi(b);
            if (a>=list_number) {
                if (pipeline) gst_element_set_state(pipeline, GST_STATE_NULL);
                play_state = IcePlayer_STOP;
                gtk_range_set_value((GtkRange *) hscale_jindu, 0);
                gtk_label_set_text(GTK_LABEL(label_info2),"状态：停止                                                                                                                    ");
                gtk_label_set_text(GTK_LABEL(label_info),"IcePlayer 听你想听                                                                                                                   ");
                gtk_container_remove(GTK_CONTAINER(eventbox_play),image_play);
                image_play=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_play,TRUE,NULL));
                gtk_widget_show(image_play);
                gtk_container_add(GTK_CONTAINER(eventbox_play),image_play);
            } else {
                play_state = IcePlayer_PLAYING;
                if (pipeline) gst_element_set_state(pipeline, GST_STATE_NULL);
                play_uri();
            }
        }
        if (play_type==1) {
            list_number=0;
            gchar b[4];
            srand((unsigned)time(NULL)+1);
            GtkTreeModel *model = gtk_tree_view_get_model(GTK_TREE_VIEW(treeview));
            gtk_tree_model_foreach(model, (GtkTreeModelForeachFunc)get_list_number,NULL);
            list_number=rand()%list_number;
            sprintf(b,"%d",list_number);
            GtkTreePath *path = gtk_tree_path_new_from_string(b);
            gtk_tree_view_set_cursor((GtkTreeView *) treeview,path, gtk_tree_view_get_column((GtkTreeView *) treeview,0), FALSE);
            if (pipeline) gst_element_set_state(pipeline, GST_STATE_NULL);
            play_state = IcePlayer_PLAYING;
            play_uri();
        }
        if (play_type==2) {
            gtk_tree_view_set_cursor((GtkTreeView *) treeview,play_path, gtk_tree_view_get_column((GtkTreeView *) treeview,0), FALSE);
            if (pipeline) gst_element_set_state(pipeline, GST_STATE_NULL);
            play_state = IcePlayer_PLAYING;
            play_uri();
        }
    }
}
gvoid stop  () {
    if (pipeline) gst_element_set_state(pipeline, GST_STATE_NULL);
    play_state = IcePlayer_STOP;
    gtk_range_set_value((GtkRange *) hscale_jindu, 0);
    gtk_container_remove(GTK_CONTAINER(eventbox_play),image_play);
    image_play=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_play,TRUE,NULL));
    gtk_widget_show(image_play);
    gtk_container_add(GTK_CONTAINER(eventbox_play),image_play);
    gtk_label_set_text(GTK_LABEL(label_info3),"00.00:00-00.00:00");
    gtk_label_set_text(GTK_LABEL(label_info2),"状态：停止                                                                                                                    ");
    gtk_label_set_text(GTK_LABEL(label_info),"IcePlayer 听你想听                                                                                                                  ");
    gtk_range_set_value((GtkRange *) hscale_jindu,0);
}
gvoid quit  () {
    if (loop) g_main_loop_quit(loop);
    if (system("pkill notify-osd"));
    if (pipeline) gst_element_set_state(GST_ELEMENT(pipeline), GST_STATE_NULL);
    save_config();
    exit(0);
}
gboolean list_reorder(GtkTreeModel *model,GtkTreePath *path,GtkTreeIter *iter,FILE *tmplog) {
    gchar *value;
    gtk_tree_model_get(model, iter, 0, &value, -1);
    gchar data[1200];
    FILE *list_file = fopen(list_file_path,"a+");
    while (fgets(data,1200,list_file)) {
        data[strlen(data)-1] = '\0';
        if (strcmp(data,value) ==0) {
            fputs(data,tmplog);
            fputc('\n',tmplog);
            if (fgets(data,1200,list_file));
            data[strlen(data)-1] = '\0';
            fputs(data,tmplog);
            fputc('\n',tmplog);
        }
    }
    fclose(list_file);
    return FALSE;
}
gboolean list_order_set(GtkTreeModel *model,GtkTreePath *path,GtkTreeIter *iter, gchar name[1200][1200]) {
    static gint n=0;
    if (name[0][0]==0) {
        n=0;
    }
    gchar *value;
    gtk_tree_model_get(model, iter, 0, &value, -1);
    strcpy(name[n++],value);
    name[n][0]=0;
    return FALSE;
}
gvoid List_order(GtkMenuItem *item, gint type) {
    gint n,m;
    list_number=0;
    gtk_tree_model_foreach( gtk_tree_view_get_model(GTK_TREE_VIEW(treeview)), (GtkTreeModelForeachFunc)get_list_number,NULL);
    gchar name[list_number][1200];
    name[0][0]=0;
    gtk_tree_model_foreach( gtk_tree_view_get_model(GTK_TREE_VIEW(treeview)), (GtkTreeModelForeachFunc)list_order_set,name);
    for (n=0;n<list_number-1;n++) {
        for (m=0;m<list_number-n-1;m++) {
            if (strcmp(name[m],name[m+1])==-1) {
                gchar tmp[1200];
                strcpy(tmp,name[m]);
                strcpy(name[m],name[m+1]);
                strcpy(name[m+1],tmp);
            }
        }
    }
    gtk_list_store_clear(  (GtkListStore *)gtk_tree_view_get_model(GTK_TREE_VIEW(treeview)));
    n = 0;
    {
        while (name[n][0]) {
            add_to_list ( treeview, (name[n++]),type);
        }
    }
    FILE *tmplog = fopen(tmp_file_path,"a+");
    gtk_tree_model_foreach( gtk_tree_view_get_model(GTK_TREE_VIEW(treeview)), (GtkTreeModelForeachFunc) list_reorder,tmplog);
    fclose(tmplog);
    unlink(list_file_path);
    gchar make_new_filelst[1200];
    g_snprintf(make_new_filelst,1200,"cp \"%s\" \"%s\"",tmp_file_path,list_file_path);
    if (system(make_new_filelst));
    unlink(tmp_file_path);
}
gboolean delete_file_same(GtkTreeModel *model,GtkTreePath *path,GtkTreeIter *iter,gpointer user_data) {
    gchar *value,value2[1200];
    gtk_tree_model_get(model, iter, 0, &value, -1);
    strcpy(value2,value);
    if (value2[strlen(value)-1]==')')
        if (strstr(value,"^(")!=0)
            if (value2[strlen(value)-2]<='9'&&value2[strlen(value)-2]>='0') {
                gtk_list_store_remove( (GtkListStore *)model, iter);
                return TRUE;
            }

    return FALSE;
}
gvoid real_delete(gchar *value) {
    gchar data[1200];
    FILE *list_file = fopen(list_file_path,"a+");
    while (fgets(data,1200,list_file)) {
        data[strlen(data)-1] = '\0';
        if (strcmp(data,value) ==0) {
            if (fgets(data,1200,list_file));
            data[strlen(data)-1] = '\0';

            gint n = strlen(data);
            gint m = 0;
            while (m+7 != n) {
                data[m] = data[m+7];
                m++;
            }
            data[m] = '\0';

            unlink(data);

        }
    }
    fclose(list_file);
}
gvoid List_delete(GtkMenuItem *item, gpointer user_data) {
    drag_lock=TRUE;
    GtkTreeModel *model = gtk_tree_view_get_model(GTK_TREE_VIEW(treeview));
    GtkTreeIter iter;
    GtkListStore *store = GTK_LIST_STORE(gtk_tree_view_get_model(GTK_TREE_VIEW(treeview)));
    selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(treeview));
    GList *list = gtk_tree_selection_get_selected_rows(GTK_TREE_SELECTION(selection),&model);
    const gchar *title = gtk_menu_item_get_label(item);
    gboolean has = FALSE;
    if (!strcmp(title,"删除选中的文件")) {
        if (list == NULL) {
            GtkWidget *dialog;
            GtkWidget *dialog_vbox;
            GtkWidget *label;
            GtkWidget *dialog_action_area;
            GtkWidget *okbutton1;
            dialog = gtk_dialog_new();
            gtk_widget_set_size_request(dialog, 180, 70);
            gtk_window_set_title(GTK_WINDOW(dialog), "");
            gtk_window_set_position(GTK_WINDOW(dialog), GTK_WIN_POS_CENTER);
            gtk_window_set_resizable(GTK_WINDOW(dialog), FALSE);
            gtk_window_set_type_hint(GTK_WINDOW(dialog), GDK_WINDOW_TYPE_HINT_DIALOG);
            dialog_vbox = GTK_DIALOG(dialog)->vbox;
            gtk_widget_show(dialog_vbox);
            label = gtk_label_new("没有选中任何文件!");
            gtk_widget_show(label);
            gtk_box_pack_start(GTK_BOX(dialog_vbox), label, FALSE, FALSE, 0);
            dialog_action_area = GTK_DIALOG(dialog)->action_area;
            gtk_widget_show(dialog_action_area);
            gtk_button_box_set_layout(GTK_BUTTON_BOX(dialog_action_area), GTK_BUTTONBOX_END);
            okbutton1 = gtk_button_new_from_stock("gtk-ok");
            gtk_widget_show(okbutton1);
            gtk_dialog_add_action_widget(GTK_DIALOG(dialog), okbutton1, GTK_RESPONSE_OK);
            GTK_WIDGET_SET_FLAGS(okbutton1, GTK_CAN_DEFAULT);
            GdkPixbuf *IcePlayer_icon_pixbuf=gdk_pixbuf_new_from_inline  (-1,pix_iceplayer,TRUE,NULL);
            gtk_window_set_icon(GTK_WINDOW(dialog),(GdkPixbuf *)IcePlayer_icon_pixbuf);
            gtk_window_set_keep_above     (GTK_WINDOW (dialog),TRUE);
            show_iceplayer=TRUE;
            gtk_window_set_focus ((GtkWindow *)IcePlayer,okbutton1);
            gtk_dialog_run((GtkDialog *) dialog);
            gtk_widget_destroy(dialog);
            show_iceplayer=FALSE;
            return ;
        }
        while (list != NULL) {
            if (gtk_tree_model_get_iter(model, &iter, (GtkTreePath *) list->data)) {
                if (!gtk_tree_path_compare( (GtkTreePath *) list->data,play_path)) {
                    has=TRUE;
                }
            }
            list = list->next;
        }
        list = gtk_tree_selection_get_selected_rows(GTK_TREE_SELECTION(selection),&model);
        while (list != NULL) {
            if (gtk_tree_model_get_iter(model, &iter, (GtkTreePath *) list->data)) {
                gtk_list_store_remove(store, &iter);
            }
            list = gtk_tree_selection_get_selected_rows(GTK_TREE_SELECTION(selection),&model);
        }
    }
    if (!strcmp(title,"删除包含\"???\"的文件")) {
        GtkWidget *dialog;
        GtkWidget *dialog_vbox;
        GtkWidget *entry;
        GtkWidget *dialog_action_area;
        GtkWidget *cancelbutton;
        GtkWidget *okbutton;
        dialog = gtk_dialog_new();
        gtk_window_set_title(GTK_WINDOW(dialog), "删除包含以下输入框中文字的文件");
        GdkPixbuf *IcePlayer_icon_pixbuf=gdk_pixbuf_new_from_inline  (-1,pix_iceplayer,TRUE,NULL);
        gtk_window_set_keep_above     (GTK_WINDOW (dialog),TRUE);
        gtk_window_set_icon(GTK_WINDOW(dialog),(GdkPixbuf *)IcePlayer_icon_pixbuf);
        gtk_window_set_type_hint(GTK_WINDOW(dialog), GDK_WINDOW_TYPE_HINT_DIALOG);
        gtk_widget_set_size_request(dialog,300,-1);
        dialog_vbox = GTK_DIALOG(dialog)->vbox;
        gtk_widget_show(dialog_vbox);
        entry = gtk_entry_new();
        gtk_widget_show(entry);
        gtk_box_pack_start(GTK_BOX(dialog_vbox), entry, FALSE, FALSE, 0);
        gtk_entry_set_invisible_char(GTK_ENTRY(entry), 9679);
        dialog_action_area = GTK_DIALOG(dialog)->action_area;
        gtk_widget_show(dialog_action_area);
        gtk_button_box_set_layout(GTK_BUTTON_BOX(dialog_action_area), GTK_BUTTONBOX_END);
        cancelbutton = gtk_button_new_from_stock("gtk-cancel");
        gtk_widget_show(cancelbutton);
        gtk_dialog_add_action_widget(GTK_DIALOG(dialog), cancelbutton, GTK_RESPONSE_CANCEL);
        GTK_WIDGET_SET_FLAGS(cancelbutton, GTK_CAN_DEFAULT);
        okbutton = gtk_button_new_from_stock("gtk-ok");
        gtk_widget_show(okbutton);
        gtk_dialog_add_action_widget(GTK_DIALOG(dialog), okbutton, GTK_RESPONSE_OK);
        GTK_WIDGET_SET_FLAGS(okbutton, GTK_CAN_DEFAULT);
        GtkAccelGroup *accel_group = gtk_accel_group_new();
        gtk_widget_add_accelerator(okbutton, "clicked", accel_group,GDK_Return, 0, GTK_ACCEL_VISIBLE);
        gtk_window_add_accel_group(GTK_WINDOW(dialog), accel_group);

        gtk_window_set_focus ((GtkWindow *)dialog,entry);

        show_iceplayer=TRUE;

        if (gtk_dialog_run((GtkDialog *) dialog) ==-5) {
            const gchar *value = gtk_entry_get_text((GtkEntry *) entry);
            if (strcmp(value,"")!=0) {
                gtk_list_store_clear(store);
                gchar data[1200];
                FILE *list_file = fopen(list_file_path,"at+");
                while (fgets(data,1200,list_file)) {
                    data[strlen(data)-1] = '\0';
                    if (strstr(data,value) ==0) {
                        add_to_list(treeview,data,0);
                    } else {
                        if (strcmp(data,play_name)==0) {
                            gtk_widget_hide((GtkWidget * )dialog);
                            GtkWidget *dialog_real = gtk_message_dialog_new(NULL,0, GTK_MESSAGE_QUESTION,GTK_BUTTONS_OK_CANCEL,"正在播放的歌曲中含有关键字，是否删除？(其余含有关键字的歌曲都将删除)");
                            if (gtk_dialog_run((GtkDialog *) dialog_real)==-5) {
                                has = TRUE;
                            } else {
                                add_to_list(treeview,play_name,0);
                            }
                            gtk_widget_destroy(dialog_real);
                        }
                    }
                    if (fgets(data,1200,list_file));
                }
                fclose(list_file);
            }
        }
        gtk_widget_destroy(dialog);
        show_iceplayer=FALSE;
    }

    if (!strcmp(title,"清空文件")) {
        if (play_state != IcePlayer_PLAYING) {
            gtk_list_store_clear(store);
            if (pipeline) gst_element_set_state(pipeline, GST_STATE_NULL);
            play_state = IcePlayer_STOP;
            gtk_label_set_text(GTK_LABEL(label_info3),"00.00:00-00.00:00");
            gtk_label_set_text(GTK_LABEL(label_info2),"状态：停止                                                                                                                    ");
            gtk_label_set_text(GTK_LABEL(label_info),"IcePlayer 听你想听                                                                                                                        ");
            gtk_container_remove(GTK_CONTAINER(eventbox_play),image_play);
            image_play=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_play,TRUE,NULL));
            gtk_widget_show(image_play);
            gtk_container_add(GTK_CONTAINER(eventbox_play),image_play);
        } else {
            GtkWidget *dialog;
            GtkWidget *dialog_vbox;
            GtkWidget *label;
            GtkWidget *dialog_action_area;
            GtkWidget *okbutton1;
            GtkWidget *okbutton2;
            GtkWidget *okbutton3;
            dialog = gtk_dialog_new();
            gtk_widget_set_size_request(dialog, 400,100);
            gtk_window_set_title(GTK_WINDOW(dialog), "");
            gtk_window_set_position(GTK_WINDOW(dialog), GTK_WIN_POS_CENTER);
            gtk_window_set_resizable(GTK_WINDOW(dialog), FALSE);
            gtk_window_set_type_hint(GTK_WINDOW(dialog), GDK_WINDOW_TYPE_HINT_DIALOG);
            dialog_vbox = GTK_DIALOG(dialog)->vbox;
            gtk_widget_show(dialog_vbox);
            label = gtk_label_new("有文件正在播放，\n“确定”清空所有，“否”保留正在播放曲目，“取消”返回。");
            gtk_widget_show(label);
            GdkPixbuf *IcePlayer_icon_pixbuf=gdk_pixbuf_new_from_inline  (-1,pix_iceplayer,TRUE,NULL);
            gtk_window_set_icon(GTK_WINDOW(dialog),(GdkPixbuf *)IcePlayer_icon_pixbuf);
            gtk_window_set_keep_above     (GTK_WINDOW (dialog),TRUE);
            gtk_box_pack_start(GTK_BOX(dialog_vbox), label, FALSE, FALSE, 0);
            dialog_action_area = GTK_DIALOG(dialog)->action_area;
            gtk_widget_show(dialog_action_area);
            gtk_button_box_set_layout(GTK_BUTTON_BOX(dialog_action_area), GTK_BUTTONBOX_CENTER);
            okbutton1 = gtk_button_new_from_stock("gtk-ok");
            gtk_widget_show(okbutton1);
            gtk_dialog_add_action_widget(GTK_DIALOG(dialog), okbutton1, GTK_RESPONSE_OK);
            okbutton2 = gtk_button_new_from_stock("gtk-no");
            gtk_widget_show(okbutton2);
            gtk_dialog_add_action_widget(GTK_DIALOG(dialog), okbutton2, GTK_RESPONSE_NO);
            okbutton3 = gtk_button_new_from_stock("gtk-cancel");
            gtk_widget_show(okbutton3);
            gtk_dialog_add_action_widget(GTK_DIALOG(dialog), okbutton3, GTK_RESPONSE_CANCEL);
            GTK_WIDGET_SET_FLAGS(okbutton1, GTK_CAN_DEFAULT);
            show_iceplayer=TRUE;

            gtk_window_set_focus ((GtkWindow *)IcePlayer,okbutton1);
            gint a = gtk_dialog_run((GtkDialog *) dialog);
            if (a==-5) {
                gtk_list_store_clear(store);
                if (pipeline) gst_element_set_state(pipeline, GST_STATE_NULL);
                play_state = IcePlayer_STOP;
                gtk_label_set_text(GTK_LABEL(label_info3),"00.00:00-00.00:00");
                gtk_label_set_text(GTK_LABEL(label_info2),"状态：停止                                                                                                                    ");
                gtk_label_set_text(GTK_LABEL(label_info),"IcePlayer 听你想听                                                                                                                ");
                gtk_container_remove(GTK_CONTAINER(eventbox_play),image_play);
                image_play=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_play,TRUE,NULL));
                gtk_widget_show(image_play);
                gtk_container_add(GTK_CONTAINER(eventbox_play),image_play);
                play_path=gtk_tree_path_new_first();
            } else {
                if (a==-9) {
                    gtk_list_store_clear(store);
                    add_to_list(treeview,play_name,0);
                    play_path=gtk_tree_path_new_first();
                    gtk_tree_view_set_cursor((GtkTreeView *) treeview,gtk_tree_path_new_first(),gtk_tree_view_get_column((GtkTreeView *) treeview,0),FALSE);
                }
            }
            gtk_widget_destroy(dialog);
            show_iceplayer=FALSE;
        }
    }
    if (!strcmp(title,"删除重复的文件")) {
        list_number=0;
        gtk_tree_model_foreach(model, (GtkTreeModelForeachFunc)get_list_number,NULL);
        while (list_number) {
            gtk_tree_model_foreach(model, (GtkTreeModelForeachFunc) delete_file_same,NULL);
            list_number--;
        }
    }
    if (!strcmp(title,"删除已不存在的文件")) {
        gtk_list_store_clear(store);
        gchar data[1200];
        gchar data2[1200];
        gchar data3[1200];
        FILE *list_file = fopen(list_file_path,"at+");
        while (fgets(data,1200,list_file)) {
            data[strlen(data)-1] = '\0';
            if (fgets(data2,1200,list_file));
            data2[strlen(data2)-1] = '\0';
            gint a = strlen(data2);
            gint b = 0;
            while (b-7<a) {
                data3[b] = data2[b+7];
                b++;
            }
            if (fopen(data3,"r") !=0)
                add_to_list(treeview,data,0);
        }
        fclose(list_file);
    }
    if (!strcmp(title,"物理删除选中的文件")) {
        if (list == NULL) {
            GtkWidget *dialog;
            GtkWidget *dialog_vbox;
            GtkWidget *label;
            GtkWidget *dialog_action_area;
            GtkWidget *okbutton1;
            dialog = gtk_dialog_new();
            gtk_widget_set_size_request(dialog, 180, 70);
            gtk_window_set_title(GTK_WINDOW(dialog), "");
            gtk_window_set_position(GTK_WINDOW(dialog), GTK_WIN_POS_CENTER);
            gtk_window_set_resizable(GTK_WINDOW(dialog), FALSE);
            gtk_window_set_type_hint(GTK_WINDOW(dialog), GDK_WINDOW_TYPE_HINT_DIALOG);
            dialog_vbox = GTK_DIALOG(dialog)->vbox;
            gtk_widget_show(dialog_vbox);
            label = gtk_label_new("没有选中任何文件!");
            gtk_widget_show(label);
            gtk_box_pack_start(GTK_BOX(dialog_vbox), label, FALSE, FALSE, 0);
            dialog_action_area = GTK_DIALOG(dialog)->action_area;
            gtk_widget_show(dialog_action_area);
            gtk_button_box_set_layout(GTK_BUTTON_BOX(dialog_action_area), GTK_BUTTONBOX_END);
            okbutton1 = gtk_button_new_from_stock("gtk-ok");
            gtk_widget_show(okbutton1);
            gtk_dialog_add_action_widget(GTK_DIALOG(dialog), okbutton1, GTK_RESPONSE_OK);
            GTK_WIDGET_SET_FLAGS(okbutton1, GTK_CAN_DEFAULT);
            show_iceplayer=TRUE;

            gtk_window_set_focus ((GtkWindow *)IcePlayer,okbutton1);
            gtk_dialog_run((GtkDialog *) dialog);
            show_iceplayer=FALSE;
            gtk_widget_destroy(dialog);
            return ;
        } else {
            GtkWidget *dialog_real = gtk_message_dialog_new(NULL,0, GTK_MESSAGE_QUESTION,GTK_BUTTONS_OK_CANCEL,"删除后无法恢复，是否确认？");
            show_iceplayer=TRUE;
            if (gtk_dialog_run((GtkDialog *) dialog_real) ==-5) {
                while (list != NULL) {
                    if (gtk_tree_model_get_iter(model, &iter, (GtkTreePath *) list->data)) {
                        gchar *value;
                        gtk_tree_model_get(model, &iter, 0, &value, -1);
                        if (strcmp(value,play_name)==0) {
                            has = TRUE;
                        }
                        real_delete(value);
                        gtk_list_store_remove(store, &iter);
                    }
                    list = gtk_tree_selection_get_selected_rows(GTK_TREE_SELECTION(selection),&model);
                }
            }
            gtk_widget_destroy(dialog_real);
            show_iceplayer=FALSE;
        }
    }

    if (has) {
        stop();
        play_path = gtk_tree_path_new_first ();
        gtk_tree_model_foreach(gtk_tree_view_get_model( (GtkTreeView               *)treeview), (GtkTreeModelForeachFunc) clear_colum_one,NULL);
    }

    FILE *tmplog = fopen(tmp_file_path,"a+");
    gtk_tree_model_foreach(model, (GtkTreeModelForeachFunc) list_reorder,tmplog);
    fclose(tmplog);
    unlink(list_file_path);
    gchar make_new_filelst[1200];
    g_snprintf(make_new_filelst,1200,"cp \"%s\" \"%s\"",tmp_file_path,list_file_path);
    if (system(make_new_filelst));
    unlink(tmp_file_path);
}
gboolean on_IcePlayer_focus_in_event (GtkWidget *IcePlayer,GdkEventButton *event,gpointer user_data) {
    drag_lock=FALSE;
    focus = TRUE;
    save_config();
    return FALSE;
}
gboolean on_IcePlayer_focus_out_event (GtkWidget *IcePlayer,GdkEventButton *event,gpointer user_data) {
    show_iceplayer = FALSE;
    focus = FALSE;
    return FALSE;
}
gboolean on_hscale_jindu_change_value (GtkRange *hscale,GtkScrollType step, gdouble value,gpointer user_data) {
    if (pipeline) {
        gint64 nanosec = (gint)(value) * GST_SECOND;
        gst_element_seek(pipeline,1.0,GST_FORMAT_TIME,GST_SEEK_FLAG_FLUSH,GST_SEEK_TYPE_SET,nanosec,GST_SEEK_TYPE_NONE,GST_CLOCK_TIME_NONE);
        gtk_range_set_value(GTK_RANGE(hscale), (gint) value);
    }
    return FALSE;
}
gboolean on_hscale_yinliang_change_value (GtkRange *hscale, GtkScrollType step,gdouble value,gpointer user_data) {
    if (pipeline) {
        set_volume(value/100.0);
        gtk_range_set_value(GTK_RANGE(hscale),  (gint)value);
    }
    return FALSE;
}
gboolean on_enter_event (GtkWidget *widget,GdkEventButton *event,gint type) {
    switch (type) {
    case 0: {
        GdkCursor* cursor = gdk_cursor_new(GDK_SB_V_DOUBLE_ARROW);
        gdk_window_set_cursor(GTK_WIDGET(widget)->window, cursor);
        gdk_cursor_destroy(cursor);
        break;
    }
    case 1: {
        gtk_container_remove(GTK_CONTAINER(eventbox_play),image_play);
        if (play_state!=IcePlayer_PLAYING)
            image_play=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_play_enter,TRUE,NULL));
        else
            image_play=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_pause_enter,TRUE,NULL));
        gtk_widget_show(image_play);
        gtk_container_add(GTK_CONTAINER(eventbox_play),image_play);
        return TRUE;
    }
    case 2: {
        gtk_container_remove(GTK_CONTAINER(eventbox_prev),image_prev);
        image_prev=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_prev_enter,TRUE,NULL));
        gtk_widget_show(image_prev);
        gtk_container_add(GTK_CONTAINER(eventbox_prev),image_prev);
        return TRUE;
    }
    case 3: {
        gtk_container_remove(GTK_CONTAINER(eventbox_next),image_next);
        image_next=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_next_enter,TRUE,NULL));
        gtk_widget_show(image_next);
        gtk_container_add(GTK_CONTAINER(eventbox_next),image_next);
        return TRUE;
    }
    case 4: {
        gtk_container_remove(GTK_CONTAINER(eventbox_stop),image_stop);
        image_stop=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_stop_enter,TRUE,NULL));
        gtk_widget_show(image_stop);
        gtk_container_add(GTK_CONTAINER(eventbox_stop),image_stop);
        return TRUE;
    }
    case 5: {
        gtk_container_remove(GTK_CONTAINER(eventbox_min),image_min);
        image_min=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_min_enter,TRUE,NULL));
        gtk_widget_show(image_min);
        gtk_container_add(GTK_CONTAINER(eventbox_min),image_min);
        return TRUE;
    }
    case 6: {
        gtk_container_remove(GTK_CONTAINER(eventbox_close),image_close);
        image_close=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_close_enter,TRUE,NULL));
        gtk_widget_show(image_close);
        gtk_container_add(GTK_CONTAINER(eventbox_close),image_close);
        return TRUE;
    }
    case 7: {
        gtk_container_remove(GTK_CONTAINER(eventbox_tools_add),image_tools_add);
        image_tools_add=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_tools_add_enter,TRUE,NULL));
        gtk_widget_show(image_tools_add);
        gtk_container_add(GTK_CONTAINER(eventbox_tools_add),image_tools_add);
        return TRUE;
    }
    case 8: {
        gtk_container_remove(GTK_CONTAINER(eventbox_tools_dele),image_tools_dele);
        image_tools_dele=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_tools_dele_enter,TRUE,NULL));
        gtk_widget_show(image_tools_dele);
        gtk_container_add(GTK_CONTAINER(eventbox_tools_dele),image_tools_dele);
        return TRUE;
    }
    case 9: {
        gtk_container_remove(GTK_CONTAINER(eventbox_tools_list),image_tools_list);
        image_tools_list=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_tools_list_enter,TRUE,NULL));
        gtk_widget_show(image_tools_list);
        gtk_container_add(GTK_CONTAINER(eventbox_tools_list),image_tools_list);
        return TRUE;
    }
    case 10: {
        gtk_container_remove(GTK_CONTAINER(eventbox_tools_mode),image_tools_mode);
        image_tools_mode=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_tools_mode_enter,TRUE,NULL));
        gtk_widget_show(image_tools_mode);
        gtk_container_add(GTK_CONTAINER(eventbox_tools_mode),image_tools_mode);
        return TRUE;
    }
    case 11: {
        gtk_window_set_focus(GTK_WINDOW(IcePlayer),treeview);
        return TRUE;
    }
    }
    return TRUE;
}
gboolean on_leave_event (GtkWidget *widget,GdkEventButton *event,gint type) {
    switch (type) {
    case 0: {
        gdk_window_set_cursor(GTK_WIDGET(widget)->window, NULL);
        break;
    }
    case 1: {
        gtk_container_remove(GTK_CONTAINER(eventbox_play),image_play);
        if (play_state!=IcePlayer_PLAYING)
            image_play=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_play,TRUE,NULL));
        else
            image_play=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_pause,TRUE,NULL));
        gtk_widget_show(image_play);
        gtk_container_add(GTK_CONTAINER(eventbox_play),image_play);
        return TRUE;
    }
    case 2: {
        gtk_container_remove(GTK_CONTAINER(eventbox_prev),image_prev);
        image_prev=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_prev,TRUE,NULL));
        gtk_widget_show(image_prev);
        gtk_container_add(GTK_CONTAINER(eventbox_prev),image_prev);
        return TRUE;
    }
    case 3: {
        gtk_container_remove(GTK_CONTAINER(eventbox_next),image_next);
        image_next=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_next,TRUE,NULL));
        gtk_widget_show(image_next);
        gtk_container_add(GTK_CONTAINER(eventbox_next),image_next);
        return TRUE;
    }
    case 4: {
        gtk_container_remove(GTK_CONTAINER(eventbox_stop),image_stop);
        image_stop=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_stop,TRUE,NULL));
        gtk_widget_show(image_stop);
        gtk_container_add(GTK_CONTAINER(eventbox_stop),image_stop);
        return TRUE;
    }
    case 5: {
        gtk_container_remove(GTK_CONTAINER(eventbox_min),image_min);
        image_min=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_min,TRUE,NULL));
        gtk_widget_show(image_min);
        gtk_container_add(GTK_CONTAINER(eventbox_min),image_min);
        return TRUE;
    }
    case 6: {
        gtk_container_remove(GTK_CONTAINER(eventbox_close),image_close);
        image_close=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_close,TRUE,NULL));
        gtk_widget_show(image_close);
        gtk_container_add(GTK_CONTAINER(eventbox_close),image_close);
        return TRUE;
    }
    case 7: {
        gtk_container_remove(GTK_CONTAINER(eventbox_tools_add),image_tools_add);
        image_tools_add=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_tools_add,TRUE,NULL));
        gtk_widget_show(image_tools_add);
        gtk_container_add(GTK_CONTAINER(eventbox_tools_add),image_tools_add);
        return TRUE;
    }
    case 8: {
        gtk_container_remove(GTK_CONTAINER(eventbox_tools_dele),image_tools_dele);
        image_tools_dele=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_tools_dele,TRUE,NULL));
        gtk_widget_show(image_tools_dele);
        gtk_container_add(GTK_CONTAINER(eventbox_tools_dele),image_tools_dele);
        return TRUE;
    }
    case 9: {
        gtk_container_remove(GTK_CONTAINER(eventbox_tools_list),image_tools_list);
        image_tools_list=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_tools_list,TRUE,NULL));
        gtk_widget_show(image_tools_list);
        gtk_container_add(GTK_CONTAINER(eventbox_tools_list),image_tools_list);
        return TRUE;
    }
    case 10: {
        gtk_container_remove(GTK_CONTAINER(eventbox_tools_mode),image_tools_mode);
        image_tools_mode=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_tools_mode,TRUE,NULL));
        gtk_widget_show(image_tools_mode);
        gtk_container_add(GTK_CONTAINER(eventbox_tools_mode),image_tools_mode);
        return TRUE;
    }

    }
    return TRUE ;
}
gboolean on_press_event (GtkWidget *widget,GdkEventButton *event,gint type) {
    switch (type) {
    case 0: {
        gtk_container_remove(GTK_CONTAINER(eventbox_close),image_close);
        image_close=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_close_on,TRUE,NULL));
        gtk_widget_show(image_close);
        gtk_container_add(GTK_CONTAINER(eventbox_close),image_close);
        return TRUE;
    }
    case 1 : {
        gtk_container_remove(GTK_CONTAINER(eventbox_min),image_min);
        image_min=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_min_on,TRUE,NULL));
        gtk_widget_show(image_min);
        gtk_container_add(GTK_CONTAINER(eventbox_min),image_min);
        return TRUE;
    }
    case 2: {
        gtk_container_remove(GTK_CONTAINER(eventbox_play),image_play);
        if (play_state!=IcePlayer_PLAYING)
            image_play=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_play_on,TRUE,NULL));
        else
            image_play=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_pause_on,TRUE,NULL));
        gtk_widget_show(image_play);
        gtk_container_add(GTK_CONTAINER(eventbox_play),image_play);
        return TRUE;
    }
    case 3 : {
        gtk_container_remove(GTK_CONTAINER(eventbox_prev),image_prev);
        image_prev=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_prev_on,TRUE,NULL));
        gtk_widget_show(image_prev);
        gtk_container_add(GTK_CONTAINER(eventbox_prev),image_prev);
        return TRUE;
    }
    case 4: {
        gtk_container_remove(GTK_CONTAINER(eventbox_next),image_next);
        image_next=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_next_on,TRUE,NULL));
        gtk_widget_show(image_next);
        gtk_container_add(GTK_CONTAINER(eventbox_next),image_next);
        return TRUE;
    }
    case 5 : {
        gtk_container_remove(GTK_CONTAINER(eventbox_stop),image_stop);
        image_stop=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_stop_on,TRUE,NULL));
        gtk_widget_show(image_stop);
        gtk_container_add(GTK_CONTAINER(eventbox_stop),image_stop);
        return TRUE;
    }
    case 6 : {
        gtk_container_remove(GTK_CONTAINER(eventbox_tools_add),image_tools_add);
        image_tools_add=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_tools_add_on,TRUE,NULL));
        gtk_widget_show(image_tools_add);
        gtk_container_add(GTK_CONTAINER(eventbox_tools_add),image_tools_add);
        return TRUE;
    }
    case 7: {
        gtk_container_remove(GTK_CONTAINER(eventbox_tools_dele),image_tools_dele);
        image_tools_dele=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_tools_dele_on,TRUE,NULL));
        gtk_widget_show(image_tools_dele);
        gtk_container_add(GTK_CONTAINER(eventbox_tools_dele),image_tools_dele);
        return TRUE;
    }
    case 8: {
        gtk_container_remove(GTK_CONTAINER(eventbox_tools_list),image_tools_list);
        image_tools_list=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_tools_list_on,TRUE,NULL));
        gtk_widget_show(image_tools_list);
        gtk_container_add(GTK_CONTAINER(eventbox_tools_list),image_tools_list);
        return TRUE;
    }
    case  9: {
        gtk_container_remove(GTK_CONTAINER(eventbox_tools_mode),image_tools_mode);
        image_tools_mode=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_tools_mode_on,TRUE,NULL));
        gtk_widget_show(image_tools_mode);
        gtk_container_add(GTK_CONTAINER(eventbox_tools_mode),image_tools_mode);
        return TRUE;
    }
    case 10: {
        drag_lock=TRUE;
        gtk_window_begin_resize_drag(GTK_WINDOW(IcePlayer),6,event->button,event->x_root,event->y_root,event->time);
        return TRUE;
    }
    case 11 : {
        drag_lock=TRUE;
        gtk_window_begin_resize_drag(GTK_WINDOW(IcePlayer),1,event->button,event->x_root,event->y_root,event->time);
        return TRUE;
    }
    case 12: {
        drag_lock=TRUE;
        gtk_window_begin_resize_drag(GTK_WINDOW(IcePlayer),6,event->button,event->x_root,event->y_root,event->time);
        return TRUE;
    }
    case 13: {
        if (event->button==3&&event->type==GDK_BUTTON_PRESS) { /*在窗口右击时*/
            GtkWidget * menu = gtk_menu_new();
            GtkWidget *menu_config = gtk_image_menu_item_new_with_mnemonic("配置");
            gtk_menu_shell_append(GTK_MENU_SHELL(menu),menu_config);
            GtkWidget *menu_about = gtk_image_menu_item_new_with_mnemonic("关于");
            gtk_menu_shell_append(GTK_MENU_SHELL(menu),menu_about);
            g_signal_connect(menu_config,"activate",G_CALLBACK(Config),NULL);
            g_signal_connect(menu_about,"activate",G_CALLBACK(About),NULL);
            gtk_widget_show_all(menu);
            drag_lock=TRUE;
            gtk_menu_popup(GTK_MENU(menu),NULL,NULL,NULL,NULL,3,gtk_get_current_event_time());
        } else {
            drag_lock=TRUE;
            gint width,height;
            gtk_window_get_size ( (GtkWindow *)IcePlayer,&width,&height);
            height2 = height;
            gtk_window_begin_move_drag(GTK_WINDOW(IcePlayer),event->button,event->x_root,event->y_root,event->time);
        }
        return FALSE;
    }
    case 14: {
        GtkTreeModel *model;
        GList *list = gtk_tree_selection_get_selected_rows(gtk_tree_view_get_selection(GTK_TREE_VIEW(treeview)),&model);
        if (event->type==GDK_2BUTTON_PRESS) {
            play_path = (GtkTreePath *) list->data;
            play_uri();
            return FALSE;
        }
        if (event->button==3) {
            GtkWidget * menu = gtk_menu_new();
            /*/**/
            GtkWidget *menu_go;
            if (play_state == IcePlayer_PLAYING) {
                menu_go = gtk_image_menu_item_new_with_mnemonic("暂停");
                gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (menu_go), gtk_image_new_from_stock ("gtk-media-pause", GTK_ICON_SIZE_MENU));
            } else {
                menu_go = gtk_image_menu_item_new_with_mnemonic("播放");
                gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (menu_go), gtk_image_new_from_stock ("gtk-media-play", GTK_ICON_SIZE_MENU));
            }
            GtkWidget *menu_prev = gtk_image_menu_item_new_with_mnemonic("上一首");
            GtkWidget *menu_next = gtk_image_menu_item_new_with_mnemonic("下一首");
            GtkWidget *menu_stop = gtk_image_menu_item_new_with_mnemonic("停止");
            gtk_menu_shell_append(GTK_MENU_SHELL(menu),menu_go );
            gtk_menu_shell_append(GTK_MENU_SHELL(menu),menu_prev );
            gtk_menu_shell_append(GTK_MENU_SHELL(menu),menu_next );
            gtk_menu_shell_append(GTK_MENU_SHELL(menu),menu_stop );
            g_signal_connect(menu_go ,"activate",G_CALLBACK(play),NULL);
            g_signal_connect(menu_prev ,"activate",G_CALLBACK(prev),NULL);
            g_signal_connect(menu_next ,"activate",G_CALLBACK(next),NULL);
            g_signal_connect(menu_stop ,"activate",G_CALLBACK(stop),NULL);
            /*/**/
            GtkWidget *menu_separator1 = gtk_separator_menu_item_new ();
            GtkWidget *menu_Open_file = gtk_image_menu_item_new_with_mnemonic("选择文件");
            gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (menu_Open_file), gtk_image_new_from_stock ("gtk-open", GTK_ICON_SIZE_MENU));
            GtkWidget *menu_Open_folder = gtk_image_menu_item_new_with_mnemonic("添加文件夹");
            gtk_menu_shell_append(GTK_MENU_SHELL(menu),menu_separator1 );
            gtk_menu_shell_append(GTK_MENU_SHELL(menu),menu_Open_file );
            gtk_menu_shell_append(GTK_MENU_SHELL(menu),menu_Open_folder );
            g_signal_connect(menu_Open_file ,"activate",G_CALLBACK(Open_Dialog),NULL);
            g_signal_connect(menu_Open_folder ,"activate",G_CALLBACK(Open_Dialog),NULL);
            /*/**/
            GtkWidget *menu_separator2 = gtk_separator_menu_item_new ();
            GtkWidget *menu_delete = gtk_image_menu_item_new_with_mnemonic("删除选中的文件");
            gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (menu_delete), gtk_image_new_from_stock ("gtk-remove", GTK_ICON_SIZE_MENU));
            GtkWidget *menu_delete_include_name = gtk_image_menu_item_new_with_mnemonic("删除包含\"???\"的文件");
            GtkWidget *menu_delete_all = gtk_image_menu_item_new_with_mnemonic("清空文件");
            GtkWidget *menu_delete_same = gtk_image_menu_item_new_with_mnemonic("删除重复的文件");
            GtkWidget *menu_real_delete = gtk_image_menu_item_new_with_mnemonic("物理删除选中的文件");
            GtkWidget *menu_delete_not_exist = gtk_image_menu_item_new_with_mnemonic("删除已不存在的文件");

            gtk_menu_shell_append(GTK_MENU_SHELL(menu),menu_separator2 );
            gtk_menu_shell_append(GTK_MENU_SHELL(menu),menu_delete );
            gtk_menu_shell_append(GTK_MENU_SHELL(menu),menu_delete_include_name );
            gtk_menu_shell_append(GTK_MENU_SHELL(menu),menu_delete_all );
            gtk_menu_shell_append(GTK_MENU_SHELL(menu),menu_delete_same );
            gtk_menu_shell_append(GTK_MENU_SHELL(menu),menu_real_delete );
            gtk_menu_shell_append(GTK_MENU_SHELL(menu),menu_delete_not_exist );

            g_signal_connect(menu_delete ,"activate",G_CALLBACK(List_delete),NULL);
            g_signal_connect(menu_delete_all ,"activate",G_CALLBACK(List_delete),NULL);
            g_signal_connect(menu_delete_include_name ,"activate",G_CALLBACK(List_delete),NULL);
            g_signal_connect(menu_delete_not_exist ,"activate",G_CALLBACK(List_delete),NULL);
            g_signal_connect(menu_delete_same ,"activate",G_CALLBACK(List_delete),NULL);
            g_signal_connect(menu_real_delete ,"activate",G_CALLBACK(List_delete),NULL);
            /*/**/
            GtkWidget *menu_separator3 = gtk_separator_menu_item_new ();
            GtkWidget *menu_list_forward = gtk_image_menu_item_new_with_mnemonic("正序");
            gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (menu_list_forward), gtk_image_new_from_stock ("gtk-refresh", GTK_ICON_SIZE_MENU));
            GtkWidget *menu_list_backward = gtk_image_menu_item_new_with_mnemonic("反序");

            gtk_menu_shell_append(GTK_MENU_SHELL(menu),menu_separator3 );
            gtk_menu_shell_append(GTK_MENU_SHELL(menu),menu_list_forward);
            gtk_menu_shell_append(GTK_MENU_SHELL(menu),menu_list_backward);
            gtk_widget_show_all(menu);
            drag_lock=TRUE;
            g_signal_connect(menu_list_forward ,"activate",G_CALLBACK(List_order),(gpointer)0);
            g_signal_connect(menu_list_backward ,"activate",G_CALLBACK(List_order),(gpointer)1);
            /*/**/
            GtkWidget *menu_separator4 = gtk_separator_menu_item_new ();
            GtkWidget *menu_normol = gtk_image_menu_item_new_with_mnemonic("顺序播放");
            GtkWidget *menu_radom = gtk_image_menu_item_new_with_mnemonic("随机播放");
            GtkWidget *menu_one = gtk_image_menu_item_new_with_mnemonic("单曲循环");
            switch (play_type) {
            case IcePlayer_Normal: {
                gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (menu_normol), gtk_image_new_from_stock ("gtk-yes", GTK_ICON_SIZE_MENU));
                gtk_label_set_markup ((GtkLabel      *)GTK_BIN (menu_normol)->child, g_markup_printf_escaped ("<span weight=\"bold\">%s</span>",gtk_label_get_text (GTK_LABEL (GTK_BIN (menu_normol)->child))));
            }
            break;
            case IcePlayer_radom: {
                gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (menu_radom), gtk_image_new_from_stock ("gtk-yes", GTK_ICON_SIZE_MENU));
                gtk_label_set_markup ((GtkLabel      *)GTK_BIN (menu_radom )->child, g_markup_printf_escaped ("<span weight=\"bold\">%s</span>",gtk_label_get_text (GTK_LABEL (GTK_BIN (menu_radom )->child))));
            }
            break;
            case IcePlayer_one: {
                gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (menu_one), gtk_image_new_from_stock ("gtk-yes", GTK_ICON_SIZE_MENU));
                gtk_label_set_markup ((GtkLabel      *)GTK_BIN (menu_one)->child, g_markup_printf_escaped ("<span weight=\"bold\">%s</span>",gtk_label_get_text (GTK_LABEL (GTK_BIN (menu_one)->child))));
            }
            break;
            }
            gtk_menu_shell_append(GTK_MENU_SHELL(menu),menu_separator4 );
            gtk_menu_shell_append(GTK_MENU_SHELL(menu),menu_normol );
            gtk_menu_shell_append(GTK_MENU_SHELL(menu),menu_radom );
            gtk_menu_shell_append(GTK_MENU_SHELL(menu),menu_one );
            g_signal_connect(menu_normol ,"activate",G_CALLBACK(Play_Type),NULL);
            g_signal_connect(menu_radom ,"activate",G_CALLBACK(Play_Type),NULL);
            g_signal_connect(menu_one ,"activate",G_CALLBACK(Play_Type),NULL);

            gtk_widget_show_all(menu);
            drag_lock=TRUE;
            gtk_menu_popup(GTK_MENU(menu),NULL,NULL,NULL,NULL,1,gtk_get_current_event_time());
            if (list!=NULL&&list->next!=NULL) {
                return TRUE;
            }
        }
        return FALSE;
    }
    }
    return TRUE;
}
gboolean on_release_event (GtkWidget *widget,GdkEventButton *event,gint type) {
    switch (type) {
    case 0: {
        gint w,h;
        gtk_widget_get_size_request(widget,&w,&h);
        if (event->x>0&&event->x<w&&event->y<h&&event->y>0) {
            quit();
        }
        return TRUE;
    }
    case 1: {
        gint w,h;
        gtk_widget_get_size_request(widget,&w,&h);
        if (event->x>0&&event->x<w&&event->y<h&&event->y>0) {
            hide();
        }
        return TRUE;
    }
    case 2: {
        gint w,h;
        gtk_widget_get_size_request(widget,&w,&h);
        if (event->x>0&&event->x<w&&event->y<h&&event->y>0) {
            play();
            gtk_container_remove(GTK_CONTAINER(eventbox_play),image_play);
            if (play_state!=IcePlayer_PLAYING)
                image_play=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_play,TRUE,NULL));
            else
                image_play=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_pause,TRUE,NULL));
            gtk_widget_show(image_play);
            gtk_container_add(GTK_CONTAINER(eventbox_play),image_play);
        }
        return TRUE;
    }
    case 3: {
        gint w,h;
        gtk_widget_get_size_request(widget,&w,&h);
        if (event->x>0&&event->x<w&&event->y<h&&event->y>0) {
            gtk_container_remove(GTK_CONTAINER(eventbox_prev),image_prev);
            image_prev=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_prev,TRUE,NULL));
            gtk_widget_show(image_prev);
            gtk_container_add(GTK_CONTAINER(eventbox_prev),image_prev);
            prev();
        }
        return TRUE;
    }
    case 4  : {
        gint w,h;
        gtk_widget_get_size_request(widget,&w,&h);
        if (event->x>0&&event->x<w&&event->y<h&&event->y>0) {
            gtk_container_remove(GTK_CONTAINER(eventbox_next),image_next);
            image_next=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_next,TRUE,NULL));
            gtk_widget_show(image_next);
            gtk_container_add(GTK_CONTAINER(eventbox_next),image_next);
            next();
        }
        return TRUE;
    }
    case 5  : {
        gint w,h;
        gtk_widget_get_size_request(widget,&w,&h);
        if (event->x>0&&event->x<w&&event->y<h&&event->y>0) {
            gtk_container_remove(GTK_CONTAINER(eventbox_stop),image_stop);
            image_stop=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_stop,TRUE,NULL));
            gtk_widget_show(image_stop);
            gtk_container_add(GTK_CONTAINER(eventbox_stop),image_stop);
            stop();
        }
        return TRUE;
    }
    case  6 : {
        gint w,h;
        gtk_widget_get_size_request(widget,&w,&h);
        if (event->x>0&&event->x<w&&event->y<h&&event->y>0) {
            GtkWidget * menu = gtk_menu_new();
            GtkWidget *menu_Open_file = gtk_image_menu_item_new_with_mnemonic("选择文件");
            gtk_menu_shell_append(GTK_MENU_SHELL(menu),menu_Open_file);
            GtkWidget *menu_Open_folder = gtk_image_menu_item_new_with_mnemonic("添加文件夹");
            gtk_menu_shell_append(GTK_MENU_SHELL(menu),menu_Open_folder);
            g_signal_connect(menu_Open_file ,"activate",G_CALLBACK(Open_Dialog),NULL);
            g_signal_connect(menu_Open_folder ,"activate",G_CALLBACK(Open_Dialog),NULL);
            gtk_widget_show_all(menu);
            drag_lock=TRUE;
            gtk_menu_popup(GTK_MENU(menu),NULL,NULL,NULL,NULL,3,gtk_get_current_event_time());
        }
        return TRUE;
    }
    case 7  : {
        gint w,h;
        gtk_widget_get_size_request(widget,&w,&h);
        if (event->x>0&&event->x<w&&event->y<h&&event->y>0) {
            GtkWidget * menu = gtk_menu_new();
            GtkWidget *menu_delete = gtk_image_menu_item_new_with_mnemonic("删除选中的文件");
            GtkWidget *menu_delete_include_name = gtk_image_menu_item_new_with_mnemonic("删除包含\"???\"的文件");
            GtkWidget *menu_delete_all = gtk_image_menu_item_new_with_mnemonic("清空文件");
            GtkWidget *menu_delete_same = gtk_image_menu_item_new_with_mnemonic("删除重复的文件");
            GtkWidget *menu_delete_not_exist = gtk_image_menu_item_new_with_mnemonic("删除已不存在的文件");
            GtkWidget *menu_real_delete = gtk_image_menu_item_new_with_mnemonic("物理删除选中的文件");
            gtk_menu_shell_append(GTK_MENU_SHELL(menu),menu_delete );
            gtk_menu_shell_append(GTK_MENU_SHELL(menu),menu_delete_include_name );
            gtk_menu_shell_append(GTK_MENU_SHELL(menu),menu_delete_all );
            gtk_menu_shell_append(GTK_MENU_SHELL(menu),menu_delete_same );
            gtk_menu_shell_append(GTK_MENU_SHELL(menu),menu_delete_not_exist );
            gtk_menu_shell_append(GTK_MENU_SHELL(menu),menu_real_delete );
            g_signal_connect(menu_delete ,"activate",G_CALLBACK(List_delete),NULL);
            g_signal_connect(menu_delete_all ,"activate",G_CALLBACK(List_delete),NULL);
            g_signal_connect(menu_delete_include_name ,"activate",G_CALLBACK(List_delete),NULL);
            g_signal_connect(menu_delete_not_exist ,"activate",G_CALLBACK(List_delete),NULL);
            g_signal_connect(menu_delete_same ,"activate",G_CALLBACK(List_delete),NULL);
            g_signal_connect(menu_real_delete ,"activate",G_CALLBACK(List_delete),NULL);
            gtk_widget_show_all(menu);
            drag_lock=TRUE;
            gtk_menu_popup(GTK_MENU(menu),NULL,NULL,NULL,NULL,3,gtk_get_current_event_time());
        }
        return TRUE;
    }
    case  8 : {
        gint w,h;
        gtk_widget_get_size_request(widget,&w,&h);
        if (event->x>0&&event->x<w&&event->y<h&&event->y>0) {
            GtkWidget *menu = gtk_menu_new();
            GtkWidget *menu_list_forward = gtk_image_menu_item_new_with_mnemonic("正序");
            GtkWidget *menu_list_backward = gtk_image_menu_item_new_with_mnemonic("反序");

            gtk_menu_shell_append(GTK_MENU_SHELL(menu),menu_list_forward);
            gtk_menu_shell_append(GTK_MENU_SHELL(menu),menu_list_backward);
            gtk_widget_show_all(menu);
            drag_lock=TRUE;
            g_signal_connect(menu_list_forward ,"activate",G_CALLBACK(List_order),(gpointer)0);
            g_signal_connect(menu_list_backward ,"activate",G_CALLBACK(List_order),(gpointer)1);

            gtk_menu_popup(GTK_MENU(menu),NULL,NULL,NULL,NULL,3,gtk_get_current_event_time());
        }
        return TRUE;
    }
    case   9: {
        gint w,h;
        gtk_widget_get_size_request(widget,&w,&h);
        if (event->x>0&&event->x<w&&event->y<h&&event->y>0) {
            GtkWidget *menu = gtk_menu_new();
            GtkWidget *menu_normol = gtk_image_menu_item_new_with_mnemonic("顺序播放");
            GtkWidget *menu_radom = gtk_image_menu_item_new_with_mnemonic("随机播放");
            GtkWidget *menu_one = gtk_image_menu_item_new_with_mnemonic("单曲循环");
            switch (play_type) {
            case IcePlayer_Normal: {
                gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (menu_normol), gtk_image_new_from_stock ("gtk-yes", GTK_ICON_SIZE_MENU));
                gtk_label_set_markup ((GtkLabel      *)GTK_BIN (menu_normol)->child, g_markup_printf_escaped ("<span weight=\"bold\">%s</span>",gtk_label_get_text (GTK_LABEL (GTK_BIN (menu_normol)->child))));

            }
            break;
            case IcePlayer_radom: {
                gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (menu_radom), gtk_image_new_from_stock ("gtk-yes", GTK_ICON_SIZE_MENU));
                gtk_label_set_markup ((GtkLabel      *)GTK_BIN (menu_radom )->child, g_markup_printf_escaped ("<span weight=\"bold\">%s</span>",gtk_label_get_text (GTK_LABEL (GTK_BIN (menu_radom )->child))));

            }
            break;
            case IcePlayer_one: {
                gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (menu_one), gtk_image_new_from_stock ("gtk-yes", GTK_ICON_SIZE_MENU));
                gtk_label_set_markup ((GtkLabel      *)GTK_BIN (menu_one)->child, g_markup_printf_escaped ("<span weight=\"bold\">%s</span>",gtk_label_get_text (GTK_LABEL (GTK_BIN (menu_one)->child))));
            }
            break;
            }
            gtk_menu_shell_append(GTK_MENU_SHELL(menu),menu_normol );
            gtk_menu_shell_append(GTK_MENU_SHELL(menu),menu_radom );
            gtk_menu_shell_append(GTK_MENU_SHELL(menu),menu_one );
            g_signal_connect(menu_normol ,"activate",G_CALLBACK(Play_Type),NULL);
            g_signal_connect(menu_radom ,"activate",G_CALLBACK(Play_Type),NULL);
            g_signal_connect(menu_one ,"activate",G_CALLBACK(Play_Type),NULL);
            gtk_widget_show_all(menu);
            drag_lock=TRUE;
            gtk_menu_popup(GTK_MENU(menu),NULL,NULL,NULL,NULL,3,gtk_get_current_event_time());
        }
        return TRUE;
    }
    case 10: {
        if (pipeline) {
            gint w,h;
            gtk_widget_get_size_request((GtkWidget *) hscale_jindu,&w,&h);
            w=w-10;
            GstFormat fmt = GST_FORMAT_TIME;
            gint64 pos;
            gint64 length;
            gst_element_query_position(pipeline, &fmt, &pos);
            gst_element_query_duration(pipeline, &fmt, &length);
            pos = (((gdouble) event->x+5) / (gdouble) w) * (gdouble) length;
            if (length>0) {
                gtk_range_set_value((GtkRange *) hscale_jindu, ((((gdouble) pos) / ((gdouble) length)) *100.0));
                gtk_range_set_range((GtkRange *) hscale_jindu, 0.0, ((gdouble) length/1000000000));
                gtk_range_set_value((GtkRange *) hscale_jindu, ((gdouble) pos/1000000000));
            }
            gint64 nanosec = (gdouble) pos/1000000000 * GST_SECOND;
            gst_element_seek(pipeline,1.0,GST_FORMAT_TIME,GST_SEEK_FLAG_FLUSH,GST_SEEK_TYPE_SET,nanosec,GST_SEEK_TYPE_NONE,GST_CLOCK_TIME_NONE);
        }
        return FALSE;
    }
    case 11: {
        if (pipeline) {
            gint w,h;
            gtk_widget_get_size_request((GtkWidget *) hscale_jindu,&w,&h);
            w=w-10;
            set_volume(((event->x*3+5) / (gdouble) w));
            gtk_range_set_range((GtkRange *) hscale_yinliang, 0.0,100.0);
            gtk_range_set_value(GTK_RANGE(hscale_yinliang), ((event->x*3+5) / (gdouble) w) *100.0);
        }
        return FALSE;
    }
    }
    return TRUE;
}
gvoid on_tray_activate_event() {
    view();
}
gvoid on_tray_menu_event() {
    GtkWidget * traymenu=gtk_menu_new();

    GtkWidget *traymenuItemView=gtk_image_menu_item_new_with_mnemonic("顯示");
    GtkWidget *traymenuItemHide=gtk_image_menu_item_new_with_mnemonic("隐藏");
    gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (traymenuItemView), gtk_image_new_from_stock ("gtk-fullscreen", GTK_ICON_SIZE_MENU));
    gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (traymenuItemHide), gtk_image_new_from_stock ("gtk-remove", GTK_ICON_SIZE_MENU));
    GtkWidget *menu_separator1 = gtk_separator_menu_item_new ();
    GtkWidget *traymenuItem_normol = gtk_image_menu_item_new_with_mnemonic("顺序播放");
    GtkWidget *traymenuItem_radom = gtk_image_menu_item_new_with_mnemonic("随机播放");
    GtkWidget *traymenuItem_one = gtk_image_menu_item_new_with_mnemonic("单曲循环");
    switch (play_type) {
    case IcePlayer_Normal: {
        gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (traymenuItem_normol), gtk_image_new_from_stock ("gtk-yes", GTK_ICON_SIZE_MENU));
        gtk_label_set_markup ((GtkLabel      *)GTK_BIN (traymenuItem_normol)->child, g_markup_printf_escaped ("<span weight=\"bold\">%s</span>",gtk_label_get_text (GTK_LABEL (GTK_BIN (traymenuItem_normol)->child))));
    }
    break;
    case IcePlayer_radom: {
        gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (traymenuItem_radom), gtk_image_new_from_stock ("gtk-yes", GTK_ICON_SIZE_MENU));
        gtk_label_set_markup ((GtkLabel      *)GTK_BIN (traymenuItem_radom )->child, g_markup_printf_escaped ("<span weight=\"bold\">%s</span>",gtk_label_get_text (GTK_LABEL (GTK_BIN (traymenuItem_radom )->child))));
    }
    break;
    case IcePlayer_one: {
        gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (traymenuItem_one), gtk_image_new_from_stock ("gtk-yes", GTK_ICON_SIZE_MENU));
        gtk_label_set_markup ((GtkLabel      *)GTK_BIN (traymenuItem_one)->child, g_markup_printf_escaped ("<span weight=\"bold\">%s</span>",gtk_label_get_text (GTK_LABEL (GTK_BIN (traymenuItem_one)->child))));
    }
    break;
    }
    GtkWidget *menu_separator2 = gtk_separator_menu_item_new ();
    GtkWidget * traymenuItemGo;
    if (play_state == IcePlayer_PLAYING) {
        traymenuItemGo=gtk_image_menu_item_new_with_mnemonic("暂停");
        gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (traymenuItemGo),gtk_image_new_from_stock ("gtk-media-pause", GTK_ICON_SIZE_MENU));
    } else {
        traymenuItemGo=gtk_image_menu_item_new_with_mnemonic("播放");
        gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (traymenuItemGo),gtk_image_new_from_stock ("gtk-media-play", GTK_ICON_SIZE_MENU));
    }

    GtkWidget *traymenuItemNext=gtk_image_menu_item_new_with_mnemonic("下首");
    gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (traymenuItemNext),gtk_image_new_from_stock ("gtk-media-next", GTK_ICON_SIZE_MENU));
    GtkWidget *traymenuItemUp=gtk_image_menu_item_new_with_mnemonic("上首");
    gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (traymenuItemUp),gtk_image_new_from_stock ("gtk-media-previous", GTK_ICON_SIZE_MENU));
    GtkWidget *traymenuItemStop=gtk_image_menu_item_new_with_mnemonic("停止");
    gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM ( traymenuItemStop),gtk_image_new_from_stock ("gtk-media-stop", GTK_ICON_SIZE_MENU));
    GtkWidget *menu_separator3 = gtk_separator_menu_item_new ();
    GtkWidget * traymenuItemExit=gtk_image_menu_item_new_with_mnemonic("退出程式");
    gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM ( traymenuItemExit), gtk_image_new_from_stock ("gtk-quit", GTK_ICON_SIZE_MENU));

    gtk_menu_shell_append(GTK_MENU_SHELL(traymenu),traymenuItemView);
    gtk_menu_shell_append(GTK_MENU_SHELL(traymenu),traymenuItemHide);
    gtk_menu_shell_append(GTK_MENU_SHELL(traymenu),menu_separator1);
    gtk_menu_shell_append(GTK_MENU_SHELL(traymenu),traymenuItem_normol );
    gtk_menu_shell_append(GTK_MENU_SHELL(traymenu),traymenuItem_radom );
    gtk_menu_shell_append(GTK_MENU_SHELL(traymenu),traymenuItem_one );
    gtk_menu_shell_append(GTK_MENU_SHELL(traymenu),menu_separator2);
    gtk_menu_shell_append(GTK_MENU_SHELL(traymenu),traymenuItemGo);
    gtk_menu_shell_append(GTK_MENU_SHELL(traymenu),traymenuItemNext);
    gtk_menu_shell_append(GTK_MENU_SHELL(traymenu),traymenuItemUp);
    gtk_menu_shell_append(GTK_MENU_SHELL(traymenu),traymenuItemStop);
    gtk_menu_shell_append(GTK_MENU_SHELL(traymenu),menu_separator3);
    gtk_menu_shell_append(GTK_MENU_SHELL(traymenu),traymenuItemExit);

    g_signal_connect((gpointer) traymenuItemView ,"activate" ,G_CALLBACK(view),NULL);
    g_signal_connect((gpointer) traymenuItemHide ,"activate" ,G_CALLBACK(hide),NULL);
    g_signal_connect(traymenuItem_normol ,"activate",G_CALLBACK(Play_Type),NULL);
    g_signal_connect(traymenuItem_radom ,"activate",G_CALLBACK(Play_Type),NULL);
    g_signal_connect(traymenuItem_one ,"activate",G_CALLBACK(Play_Type),NULL);
    g_signal_connect((gpointer) traymenuItemGo ,"activate" ,G_CALLBACK(play),NULL);
    g_signal_connect((gpointer) traymenuItemUp ,"activate" ,G_CALLBACK(prev),NULL);
    g_signal_connect((gpointer) traymenuItemNext ,"activate" ,G_CALLBACK(next),NULL);
    g_signal_connect((gpointer) traymenuItemStop ,"activate" ,G_CALLBACK(stop),NULL);
    g_signal_connect((gpointer) traymenuItemExit ,"activate" ,G_CALLBACK(quit),NULL);

    gtk_widget_show_all(traymenu);
    gtk_menu_popup (GTK_MENU(traymenu),NULL,NULL,NULL,NULL,3,gtk_get_current_event_time());
}
gvoid create_IcePlayer(gvoid) {
    IcePlayer=gtk_window_new(GTK_WINDOW_TOPLEVEL);
    gtk_widget_set_size_request(IcePlayer,300,3);
    gtk_window_set_decorated(GTK_WINDOW(IcePlayer),FALSE); /*没有边框*/
    gtk_window_resize(GTK_WINDOW(IcePlayer),300,420);
    gtk_window_set_skip_taskbar_hint(GTK_WINDOW(IcePlayer),TRUE);
    gtk_window_stick (GTK_WINDOW(IcePlayer));
    GdkPixbuf *IcePlayer_icon_pixbuf=gdk_pixbuf_new_from_inline  (-1,pix_iceplayer,TRUE,NULL);
    gtk_window_set_icon(GTK_WINDOW(IcePlayer),(GdkPixbuf *)IcePlayer_icon_pixbuf);

    GtkStatusIcon *trayIcon=gtk_status_icon_new_from_pixbuf((GdkPixbuf *)IcePlayer_icon_pixbuf);
    gtk_status_icon_set_visible(GTK_STATUS_ICON(trayIcon),TRUE);

    vbox_main=gtk_vbox_new(FALSE,0);
    gtk_widget_show(vbox_main);
    gtk_container_add(GTK_CONTAINER(IcePlayer),vbox_main);

    fixed=gtk_fixed_new();
    gtk_widget_show(fixed);
    gtk_box_pack_start(GTK_BOX(vbox_main),fixed,FALSE,FALSE,0);
    gtk_widget_set_size_request(fixed,-1,128);

    eventbox_main=gtk_event_box_new();
    gtk_widget_show(eventbox_main);
    gtk_fixed_put(GTK_FIXED(fixed),eventbox_main,0,-1);
    gtk_widget_set_size_request(eventbox_main,300,130);
    gtk_event_box_set_visible_window((GtkEventBox *) eventbox_main,FALSE);

    image_main=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_main,TRUE,NULL));
    gtk_widget_show(image_main);
    gtk_container_add(GTK_CONTAINER(eventbox_main),image_main);
    gtk_widget_set_size_request(image_main,300,130);

    eventbox_prev=gtk_event_box_new();
    gtk_widget_show(eventbox_prev);
    gtk_fixed_put(GTK_FIXED(fixed),eventbox_prev,20,40);
    gtk_widget_set_size_request(eventbox_prev,20,20);

    image_prev=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_prev,TRUE,NULL));
    gtk_widget_show(image_prev);
    gtk_container_add(GTK_CONTAINER(eventbox_prev),image_prev);
    gtk_widget_set_size_request(image_prev,20,20);

    eventbox_play=gtk_event_box_new();
    gtk_widget_show(eventbox_play);
    gtk_fixed_put(GTK_FIXED(fixed),eventbox_play,46,40);
    gtk_widget_set_size_request(eventbox_play,20,20);

    image_play=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_play,TRUE,NULL));
    gtk_widget_show(image_play);
    gtk_container_add(GTK_CONTAINER(eventbox_play),image_play);
    gtk_widget_set_size_request(image_play,20,20);

    eventbox_next=gtk_event_box_new();
    gtk_widget_show(eventbox_next);
    gtk_fixed_put(GTK_FIXED(fixed),eventbox_next,20+26*2,40);
    gtk_widget_set_size_request(eventbox_next,20,20);

    image_next=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_next,TRUE,NULL));
    gtk_widget_show(image_next);
    gtk_container_add(GTK_CONTAINER(eventbox_next),image_next);
    gtk_widget_set_size_request(image_next,20,20);

    eventbox_stop=gtk_event_box_new();
    gtk_widget_show(eventbox_stop);
    gtk_fixed_put(GTK_FIXED(fixed),eventbox_stop,20+26*3,40);
    gtk_widget_set_size_request(eventbox_stop,20,20);

    image_stop=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_stop,TRUE,NULL));
    gtk_widget_show(image_stop);
    gtk_container_add(GTK_CONTAINER(eventbox_stop),image_stop);
    gtk_widget_set_size_request(image_stop,20,20);

    hscale_jindu=gtk_hscale_new(GTK_ADJUSTMENT(gtk_adjustment_new(0,0,0,0,0,0)));
    gtk_widget_show(hscale_jindu);
    gtk_fixed_put(GTK_FIXED(fixed),hscale_jindu,12,113);
    gtk_widget_set_size_request(hscale_jindu,200,7);
    gtk_scale_set_draw_value(GTK_SCALE(hscale_jindu),FALSE);

    hscale_yinliang=gtk_hscale_new(GTK_ADJUSTMENT(gtk_adjustment_new(0,0,0,0,0,0)));
    gtk_widget_show(hscale_yinliang);
    gtk_fixed_put(GTK_FIXED(fixed),hscale_yinliang,215,113);
    gtk_widget_set_size_request(hscale_yinliang,75,7);
    gtk_scale_set_draw_value(GTK_SCALE(hscale_yinliang),FALSE);
    gtk_range_set_range((GtkRange *) hscale_yinliang, 0.0,100.0);
    gtk_range_set_value(GTK_RANGE(hscale_yinliang),100);

    label_info=gtk_label_new("");
    gtk_widget_show(label_info);
    gtk_fixed_put(GTK_FIXED(fixed),label_info,13,58);
    gtk_widget_set_size_request(label_info,275,35);
    gtk_label_set_use_markup(GTK_LABEL(label_info),TRUE);
    gtk_label_set_text(GTK_LABEL(label_info),"IcePlayer 听你想听                                                                                                                            ");

    label_info2=gtk_label_new("");
    gtk_widget_show(label_info2);
    gtk_fixed_put(GTK_FIXED(fixed),label_info2,13,82);
    gtk_widget_set_size_request(label_info2,200,35);
    gtk_label_set_use_markup(GTK_LABEL(label_info2),TRUE);
    gtk_label_set_text(GTK_LABEL(label_info2),"状态：停止                                                                                                                    ");

    label_info3=gtk_label_new("");
    gtk_widget_show(label_info3);
    gtk_fixed_put(GTK_FIXED(fixed),label_info3,200,85);
    gtk_widget_set_size_request(label_info3,100,35);
    gtk_label_set_use_markup(GTK_LABEL(label_info3),TRUE);
    gtk_label_set_text(GTK_LABEL(label_info3),"00.00:00-00.00:00");

    hbox_list=gtk_hbox_new(FALSE,0);
    gtk_widget_show(hbox_list);
    gtk_box_pack_start(GTK_BOX(vbox_main),hbox_list,TRUE,TRUE,0);

    image_list_left=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_list_left,TRUE,NULL));
    gtk_widget_show(image_list_left);
    gtk_box_pack_start(GTK_BOX(hbox_list),image_list_left,FALSE,FALSE,0);
    gtk_widget_set_size_request(image_list_left,13,50);

    scrolledwindow=gtk_scrolled_window_new(NULL,NULL);
    gtk_widget_show(scrolledwindow);
    gtk_box_pack_start(GTK_BOX(hbox_list),scrolledwindow,TRUE,TRUE,0);
    gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scrolledwindow),GTK_POLICY_NEVER,GTK_POLICY_AUTOMATIC);

    treeview=gtk_tree_view_new();
    gtk_widget_show(treeview);
    gtk_container_add(GTK_CONTAINER(scrolledwindow),treeview);
    gtk_tree_view_set_reorderable(GTK_TREE_VIEW(treeview), TRUE);
    gtk_tree_view_set_headers_visible(GTK_TREE_VIEW(treeview), FALSE);
    init_list(treeview);
    selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(treeview));
    gtk_tree_selection_set_mode(selection,GTK_SELECTION_MULTIPLE);

    image_list_right=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_list_right,TRUE,NULL));
    gtk_widget_show(image_list_right);
    gtk_box_pack_start(GTK_BOX(hbox_list),image_list_right,FALSE,FALSE,0);
    gtk_widget_set_size_request(image_list_right,10,50);

    fixed_list=gtk_fixed_new();
    gtk_widget_show(fixed_list);
    gtk_box_pack_start(GTK_BOX(vbox_main),fixed_list,FALSE,FALSE,0);

    eventbox_list_down=gtk_event_box_new();
    gtk_widget_show(eventbox_list_down);
    gtk_fixed_put(GTK_FIXED(fixed_list),eventbox_list_down,-1,0);
    gtk_widget_set_size_request(eventbox_list_down,302,40);
    gtk_event_box_set_visible_window((GtkEventBox *) eventbox_list_down,FALSE); /*不让eventbox覆盖其他控件*/

    image_list_down=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_list_down,TRUE,NULL));
    gtk_widget_show(image_list_down);
    gtk_container_add(GTK_CONTAINER(eventbox_list_down),image_list_down);
    gtk_widget_set_size_request(image_list_down,302,40);

    eventbox_tools_add=gtk_event_box_new();
    gtk_widget_show(eventbox_tools_add);
    gtk_fixed_put(GTK_FIXED(fixed_list),eventbox_tools_add,45,10);
    gtk_widget_set_size_request(eventbox_tools_add,50,21);

    image_tools_add=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_tools_add,TRUE,NULL));
    gtk_container_add(GTK_CONTAINER(eventbox_tools_add),image_tools_add);
    gtk_widget_show(image_tools_add);
    gtk_widget_set_size_request(image_tools_add,50,21);

    eventbox_tools_dele=gtk_event_box_new();
    gtk_widget_show(eventbox_tools_dele);
    gtk_fixed_put(GTK_FIXED(fixed_list),eventbox_tools_dele,100,10);
    gtk_widget_set_size_request(eventbox_tools_dele,50,21);

    image_tools_dele=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_tools_dele,TRUE,NULL));
    gtk_widget_show(image_tools_dele);
    gtk_container_add(GTK_CONTAINER(eventbox_tools_dele),image_tools_dele);
    gtk_widget_set_size_request(image_tools_dele,50,21);

    eventbox_tools_list=gtk_event_box_new();
    gtk_widget_show(eventbox_tools_list);
    gtk_fixed_put(GTK_FIXED(fixed_list),eventbox_tools_list,155,10);
    gtk_widget_set_size_request(eventbox_tools_list,50,21);

    image_tools_list=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_tools_list,TRUE,NULL));
    gtk_widget_show(image_tools_list);
    gtk_container_add(GTK_CONTAINER(eventbox_tools_list),image_tools_list);
    gtk_widget_set_size_request(image_tools_list,50,21);

    eventbox_tools_mode=gtk_event_box_new();
    gtk_widget_show(eventbox_tools_mode);
    gtk_fixed_put(GTK_FIXED(fixed_list),eventbox_tools_mode,210,10);
    gtk_widget_set_size_request(eventbox_tools_mode,50,21);

    image_tools_mode=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_tools_mode,TRUE,NULL));
    gtk_widget_show(image_tools_mode);
    gtk_container_add(GTK_CONTAINER(eventbox_tools_mode),image_tools_mode);
    gtk_widget_set_size_request(image_tools_mode,50,21);

    eventbox_min=gtk_event_box_new();
    gtk_widget_show(eventbox_min);
    gtk_fixed_put(GTK_FIXED(fixed),eventbox_min,242,7);
    gtk_widget_set_size_request(eventbox_min,20,19);
    gtk_event_box_set_visible_window((GtkEventBox *) eventbox_min,FALSE);

    image_min=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_min,TRUE,NULL));
    gtk_widget_show(image_min);
    gtk_container_add(GTK_CONTAINER(eventbox_min),image_min);
    gtk_widget_set_size_request(image_min,20,19);

    eventbox_close=gtk_event_box_new();
    gtk_widget_show(eventbox_close);
    gtk_fixed_put(GTK_FIXED(fixed),eventbox_close,273,7);
    gtk_widget_set_size_request(eventbox_close,20,19);
    gtk_event_box_set_visible_window((GtkEventBox *) eventbox_close,FALSE);

    image_close=gtk_image_new_from_pixbuf (gdk_pixbuf_new_from_inline  (-1,pix_close,TRUE,NULL));
    gtk_widget_show(image_close);
    gtk_container_add(GTK_CONTAINER(eventbox_close),image_close);
    gtk_widget_set_size_request(image_close,20,19);

    eventbox_left_top=gtk_event_box_new();
    gtk_widget_show(eventbox_left_top);
    gtk_fixed_put(GTK_FIXED(fixed),eventbox_left_top,-1,-1);
    gtk_widget_set_size_request(eventbox_left_top,25,20);
    gtk_event_box_set_visible_window((GtkEventBox *) eventbox_left_top,FALSE);

    eventbox_right_down=gtk_event_box_new();
    gtk_widget_show(eventbox_right_down);
    gtk_fixed_put(GTK_FIXED(fixed_list),eventbox_right_down,271,0);
    gtk_widget_set_size_request(eventbox_right_down,30,50);
    gtk_event_box_set_visible_window((GtkEventBox *) eventbox_right_down,FALSE);

    eventbox_left_down=gtk_event_box_new();
    gtk_widget_show(eventbox_left_down);
    gtk_fixed_put(GTK_FIXED(fixed_list),eventbox_left_down,-1,0);
    gtk_widget_set_size_request(eventbox_left_down,30,50);
    gtk_event_box_set_visible_window((GtkEventBox *) eventbox_left_down,FALSE);

    g_signal_connect((gpointer) IcePlayer ,"delete_event" ,G_CALLBACK(quit),NULL);
    g_signal_connect((gpointer) IcePlayer ,"button_press_event" ,G_CALLBACK(on_press_event),(gpointer )13);
    g_signal_connect((gpointer) IcePlayer ,"focus_in_event" ,G_CALLBACK(on_IcePlayer_focus_in_event),NULL);
    g_signal_connect((gpointer) IcePlayer ,"focus_out_event" ,G_CALLBACK(on_IcePlayer_focus_out_event),NULL);
    g_signal_connect((gpointer) trayIcon  , "activate", G_CALLBACK (on_tray_activate_event), NULL);
    g_signal_connect((gpointer) trayIcon  , "popup-menu", G_CALLBACK (on_tray_menu_event), NULL);
    g_signal_connect((gpointer) eventbox_play ,"button_press_event" ,G_CALLBACK(on_press_event),(gpointer )2);
    g_signal_connect((gpointer) eventbox_play ,"enter-notify-event" ,G_CALLBACK(on_enter_event),(gpointer )1);
    g_signal_connect((gpointer) eventbox_play ,"button_release_event",G_CALLBACK(on_release_event),(gpointer )2);
    g_signal_connect((gpointer) eventbox_play ,"leave-notify-event" ,G_CALLBACK(on_leave_event),(gpointer )1);
    g_signal_connect((gpointer) eventbox_prev ,"button_press_event" ,G_CALLBACK(on_press_event),(gpointer )3);
    g_signal_connect((gpointer) eventbox_prev ,"enter-notify-event" ,G_CALLBACK(on_enter_event),(gpointer )2);
    g_signal_connect((gpointer) eventbox_prev ,"button_release_event",G_CALLBACK(on_release_event),(gpointer )3);
    g_signal_connect((gpointer) eventbox_prev ,"leave-notify-event" ,G_CALLBACK(on_leave_event),(gpointer )2);
    g_signal_connect((gpointer) eventbox_next ,"button_press_event" ,G_CALLBACK(on_press_event),(gpointer )4);
    g_signal_connect((gpointer) eventbox_next ,"enter-notify-event" ,G_CALLBACK(on_enter_event),(gpointer )3);
    g_signal_connect((gpointer) eventbox_next ,"button_release_event",G_CALLBACK(on_release_event),(gpointer )4);
    g_signal_connect((gpointer) eventbox_next ,"leave-notify-event" ,G_CALLBACK(on_leave_event),(gpointer )3);
    g_signal_connect((gpointer) eventbox_stop ,"button_press_event" ,G_CALLBACK(on_press_event),(gpointer )5);
    g_signal_connect((gpointer) eventbox_stop ,"enter-notify-event" ,G_CALLBACK(on_enter_event),(gpointer )4);
    g_signal_connect((gpointer) eventbox_stop ,"button_release_event",G_CALLBACK(on_release_event),(gpointer )5);
    g_signal_connect((gpointer) eventbox_stop ,"leave-notify-event" ,G_CALLBACK(on_leave_event),(gpointer )4);
    g_signal_connect((gpointer) eventbox_min ,"button_press_event" ,G_CALLBACK(on_press_event),(gpointer )1);
    g_signal_connect((gpointer) eventbox_min ,"button_release_event",G_CALLBACK(on_release_event),(gpointer )1);
    g_signal_connect((gpointer) eventbox_min ,"enter-notify-event" ,G_CALLBACK(on_enter_event),(gpointer )5);
    g_signal_connect((gpointer) eventbox_min ,"leave-notify-event" ,G_CALLBACK(on_leave_event),(gpointer )5);
    g_signal_connect((gpointer) eventbox_close ,"button_press_event" ,G_CALLBACK(on_press_event),(gpointer )0);
    g_signal_connect((gpointer) eventbox_close ,"button_release_event",G_CALLBACK(on_release_event),(gpointer )0);
    g_signal_connect((gpointer) eventbox_close ,"enter-notify-event" ,G_CALLBACK(on_enter_event),(gpointer )6);
    g_signal_connect((gpointer) eventbox_close ,"leave-notify-event" ,G_CALLBACK(on_leave_event),(gpointer )6);
    g_signal_connect((gpointer) hscale_jindu ,"button_release_event",G_CALLBACK(on_release_event),(gpointer )10);
    g_signal_connect((gpointer) hscale_jindu ,"change-value" ,G_CALLBACK(on_hscale_jindu_change_value), NULL);
    g_signal_connect((gpointer) hscale_yinliang ,"change-value" ,G_CALLBACK(on_hscale_yinliang_change_value), NULL);
    g_signal_connect((gpointer) hscale_yinliang ,"button_release_event",G_CALLBACK(on_release_event),(gpointer )11);
    g_signal_connect((gpointer) hscale_jindu ,"focus_in_event",G_CALLBACK(on_enter_event),(gpointer )11);
    g_signal_connect((gpointer) hscale_yinliang ,"focus_in_event",G_CALLBACK(on_enter_event),(gpointer )11);
    g_signal_connect((gpointer) treeview ,"button_press_event" ,G_CALLBACK(on_press_event),(gpointer )14);
    g_signal_connect((gpointer) treeview ,"button_release_event",G_CALLBACK(on_press_event),(gpointer )14);
    g_signal_connect((gpointer) selection ,"changed" ,G_CALLBACK(on_treeview_selection_changed),NULL);
    g_signal_connect((gpointer) eventbox_tools_add ,"button_press_event" ,G_CALLBACK(on_press_event),(gpointer )6);
    g_signal_connect((gpointer) eventbox_tools_add ,"enter-notify-event" ,G_CALLBACK(on_enter_event),(gpointer )7);
    g_signal_connect((gpointer) eventbox_tools_add ,"button_release_event",G_CALLBACK(on_release_event),(gpointer )6);
    g_signal_connect((gpointer) eventbox_tools_add ,"leave-notify-event" ,G_CALLBACK(on_leave_event),(gpointer )7);
    g_signal_connect((gpointer) eventbox_tools_dele ,"button_press_event" ,G_CALLBACK(on_press_event),(gpointer )7);
    g_signal_connect((gpointer) eventbox_tools_dele ,"enter-notify-event" ,G_CALLBACK(on_enter_event),(gpointer )8);
    g_signal_connect((gpointer) eventbox_tools_dele ,"button_release_event",G_CALLBACK(on_release_event),(gpointer )7);
    g_signal_connect((gpointer) eventbox_tools_dele ,"leave-notify-event" ,G_CALLBACK(on_leave_event),(gpointer )8);
    g_signal_connect((gpointer) eventbox_tools_list ,"button_press_event" ,G_CALLBACK(on_press_event),(gpointer )8);
    g_signal_connect((gpointer) eventbox_tools_list ,"enter-notify-event" ,G_CALLBACK(on_enter_event),(gpointer )9);
    g_signal_connect((gpointer) eventbox_tools_list ,"button_release_event",G_CALLBACK(on_release_event),(gpointer )8);
    g_signal_connect((gpointer) eventbox_tools_list ,"leave-notify-event" ,G_CALLBACK(on_leave_event),(gpointer )9);
    g_signal_connect((gpointer) eventbox_tools_mode ,"button_press_event" ,G_CALLBACK(on_press_event),(gpointer )9);
    g_signal_connect((gpointer) eventbox_tools_mode ,"enter-notify-event" ,G_CALLBACK(on_enter_event),(gpointer )10);
    g_signal_connect((gpointer) eventbox_tools_mode ,"button_release_event",G_CALLBACK(on_release_event),(gpointer )9);
    g_signal_connect((gpointer) eventbox_tools_mode ,"leave-notify-event" ,G_CALLBACK(on_leave_event),(gpointer )10);
    g_signal_connect((gpointer) eventbox_right_down ,"button_press_event" ,G_CALLBACK(on_press_event),(gpointer )10);
    g_signal_connect((gpointer) eventbox_left_top ,"button_press_event" ,G_CALLBACK(on_press_event),(gpointer )11);
    g_signal_connect((gpointer) eventbox_left_down ,"button_press_event" ,G_CALLBACK(on_press_event),(gpointer )12);
    g_signal_connect((gpointer) eventbox_left_down ,"enter-notify-event" ,G_CALLBACK(on_enter_event),(gpointer )0);
    g_signal_connect((gpointer) eventbox_left_down ,"leave-notify-event" ,G_CALLBACK(on_leave_event),(gpointer )0);
    g_signal_connect((gpointer) eventbox_right_down ,"enter-notify-event" ,G_CALLBACK(on_enter_event),(gpointer )0);
    g_signal_connect((gpointer) eventbox_right_down ,"leave-notify-event" ,G_CALLBACK(on_leave_event),(gpointer )0);
    g_signal_connect((gpointer) eventbox_left_top ,"enter-notify-event" ,G_CALLBACK(on_enter_event),(gpointer )0);
    g_signal_connect((gpointer) eventbox_left_top ,"leave-notify-event" ,G_CALLBACK(on_leave_event),(gpointer )0);

    read_config();

    gtk_widget_show(IcePlayer);

    g_timeout_add(500, (GSourceFunc) update_time,NULL);

    GtkTreeModel *model;
    GList *list = gtk_tree_selection_get_selected_rows(gtk_tree_view_get_selection(GTK_TREE_VIEW(treeview)),&model);
    if (save_if_play) {
        if (list) {
            play_path = (GtkTreePath *) list->data;
            play();
        }
    } else {
        if (system("pkill notify-osd"));
        notify_init("IcePlayer");
        NotifyNotification *notify = notify_notification_new("welcome", "欢迎使用iceplayer", NULL, NULL);
        notify_notification_show(notify, NULL);
    }
    if (save_file_playing) {
        if (list) {
            stop();
        }
    }
    if (save_yinliang) {
        set_volume(volume);
    }

    gtk_main();
}
gint main(gint argc,gchar *argv[]) {
    gtk_init(&argc,&argv);
    gst_init(&argc,&argv);

    strcpy (list_file_path,g_get_home_dir());
    strcat(list_file_path,"/.IcePlayer/filelist");
    strcpy (config_file_path,g_get_home_dir());
    strcat(config_file_path,"/.IcePlayer/config");
    strcpy (tmp_file_path,g_get_tmp_dir());
    strcat(tmp_file_path,"/IcePlayer.log");
    gchar system_name[200];
    strcpy(system_name,"mkdir -p ");
    strcat(system_name,g_get_home_dir());
    strcat(system_name,"/.IcePlayer");
    if (system(system_name));

    if (system("ps -C iceplayer > /tmp/IcePlayer.log"));
    FILE *file = fopen(tmp_file_path,"a+");
    gchar nnm[1200];
    if (fgets(nnm,1200,file))
        if (fgets(nnm,1200,file))
            if (fgets(nnm,1200,file)) {
                unlink(tmp_file_path);


                GtkWidget *dialog;
                GtkWidget *dialog_vbox1;
                GtkWidget *label1;
                GtkWidget *dialog_action_area1;
                GtkWidget *applybutton1;
                GtkWidget *cancelbutton1;
                GtkWidget *okbutton1;

                dialog = gtk_dialog_new ();
                gtk_window_set_title (GTK_WINDOW (dialog), "iceplayer");
                gtk_window_set_type_hint (GTK_WINDOW (dialog), GDK_WINDOW_TYPE_HINT_DIALOG);

                dialog_vbox1 = GTK_DIALOG (dialog)->vbox;
                gtk_widget_show (dialog_vbox1);

                label1 = gtk_label_new ("IcePlayer已经在运行！\n若是程序出错，\n“应用”键清空配置文件和播放列表，\n“确定键将试图终止外部程序并重新启动程序。");
                gtk_widget_show (label1);
                gtk_box_pack_start (GTK_BOX (dialog_vbox1), label1, FALSE, FALSE, 0);

                dialog_action_area1 = GTK_DIALOG (dialog)->action_area;
                gtk_widget_show (dialog_action_area1);
                gtk_button_box_set_layout (GTK_BUTTON_BOX (dialog_action_area1), GTK_BUTTONBOX_END);

                applybutton1 = gtk_button_new_from_stock ("gtk-apply");
                gtk_widget_show (applybutton1);
                gtk_dialog_add_action_widget (GTK_DIALOG (dialog), applybutton1, GTK_RESPONSE_APPLY);
                GTK_WIDGET_SET_FLAGS (applybutton1, GTK_CAN_DEFAULT);

                cancelbutton1 = gtk_button_new_from_stock ("gtk-cancel");
                gtk_widget_show (cancelbutton1);
                gtk_dialog_add_action_widget (GTK_DIALOG (dialog), cancelbutton1, GTK_RESPONSE_CANCEL);
                GTK_WIDGET_SET_FLAGS (cancelbutton1, GTK_CAN_DEFAULT);

                okbutton1 = gtk_button_new_from_stock ("gtk-ok");
                gtk_widget_show (okbutton1);
                gtk_dialog_add_action_widget (GTK_DIALOG (dialog), okbutton1, GTK_RESPONSE_OK);
                GTK_WIDGET_SET_FLAGS (okbutton1, GTK_CAN_DEFAULT);

                gint a= gtk_dialog_run((GtkDialog *)dialog);
                if (a==-5) {
                    gtk_widget_destroy (dialog);
                    if (system("pkill -o iceplayer"));
                } else {
                    if (a==-10) {
                        gtk_widget_destroy (dialog);
                        unlink(list_file_path);
                        unlink(config_file_path);
                        if (system("pkill -o iceplayer"));
                    } else {
                        gtk_widget_destroy (dialog);
                        fclose(file);
                        return 0;
                    }
                }
            }

    unlink(tmp_file_path);
    fclose(file);

    create_IcePlayer();

    return 0;
}
